;-----------------------------------------------------------------------------
TITLE "- GPWS 98"
DESCRIPTION "Ground Proximity Warning System 98 V8.0 "
DESCRIPTION "Warnings, AP & Radio Utilities, Autoland   "
DESCRIPTION "(C) 1998 Wilco van Deijl "
;-----------------------------------------------------------------------------

;Compile with APLC32 V1.24 or higher, differences between versions which need
;to be compiled with the -a option and without this option are indicated by:
;[m]   ->  compile without -a option  (altitudes in metres)
;[-a]  ->  compile with the -a option (altitudes in ft, alt compensation off)
;Differences between standard and module version are indicated by {} comments
;throughout this code. {also disable title and description for module}

; Startup ********************************************************************
APL_SOUND=1
;DECLARE init                                ;{add for module}
;IF init                                     ;{add for module} 
;    GOTO gpws                               ;{add for module} 
;ENDIF                                       ;{add for module} 
;init=1                                      ;{add for module} 
ADV_KEYS CLEAR                              ;{delete for module}
ONEXP_CLEAR                                 ;{delete for module}

; Declaring variables ********************************************************
DECLARE DH_key, GPWS_key, BANK_key, TRIM_key, VOICE_key, SPDCALL_key, END_key
DECLARE APHDG_key, APALT_key, DN_key, UP_key, L1_key, R1_key, L10_key, R10_key
DECLARE CAT_key, LAND_key, RTD_key, REV_key, keyA, keyB, keyC, keyD, keyE
DECLARE ADF_key, COM_key, NAV1_key, NAV2_key, XPDR_key
DECLARE COM2_key, RATE_key, CRS_key, TO_key, FR_key, DIST_key
DECLARE key1, key2, key3, key4, key5, key6, key7, key8, key9, key0

DECLARE altcall, aplrate, bank, bankangle, com1rate, dh, gear
DECLARE gpws, gpwsmode, ias, ias0, lastcall, ra, ra0, sinkalt
DECLARE tdtime, time, time0, towarn, val, voice, vs, x1, x2
DECLARE alertalt, altalert, altdev, trim, trimsound
DECLARE spd, spdcall, spdtime, tocall, tospd, v1r, v2r, vaa, vr
DECLARE hdg, alt, flch, autoland, cat, vscount, vsfinal, vstime
DECLARE autortd, autorev, reverse, thr, thrlimit
DECLARE adf, com, crs, freq, nav1, nav2, swap
DECLARE atcgroup, atcmsg, atis, atistime, com2, com2freq
DECLARE com2rate, lastmsg, msgpause, msgtime, playtime
DECLARE attend, belts, belts0, brfg, brtime, chtime, crzalt, pbrk
DECLARE aplc32_version, aplrate_min, perf_high

; Testing systems / apl performance ************************************************************
PRINT_TIME 20
PRINT "TESTING SYSTEMS"                     ;{delete for module}
IF aplc32_version>0 AND aplc32_version<124
    PRINT "You need to upgrade your copy of APLC32"
    WAIT 8
ENDIF
aplrate_min=13                              ;minimum apl rate
perf_high=5                                 ;perf start value
GOSUB set_aplrate                           ;set apl rate (by adjusting perf)

; Default settings / Initialising variables **********************************
nav1=NAV1_FREQ          ;Store active frequency in standby frequency
nav2=NAV2_FREQ          ;
adf=ADF_FREQ            ;
;COM_FREQ=118.1          ;Set active com freq 
;com=iFSSFreq            ;Set standby com freq  {add for ProFlight98 module}
;com=fis_freq/100        ;Set standby com freq  {add for WinPlanner4 module}
com=122.0               ;Set standby com freq  {delete for PF98/WPP4 module}
;com2freq=118.1          ;Set active com2 freq              {add for module}
;com2=122.0              ;Set standby com2 freq             {add for module}
;com1rate=9              ;Default rate of ATC (0-9)         {add for module}
com2rate=5              ;Default rate of random ATC messages (0-9)
msgpause=10             ;Minimum time between random ATC messages (seconds)
                        ; (can also be adjusted for each ATC freq, see end)
attend=1                ;Flt attendant (0=off, 1=on)
belts=0                 ;Fasten belts  (0=off, 1=auto, 3=on)
gpws=5                  ;GPWS mode     (0=off, 1=altitude calls only, 5=on)
bankangle=35            ;Bank angle    (0=off, 35, 50, 65, ... degrees)
trimsound=2             ;Trim sound    (0=off, 1=manual, 2=on)
voice=3                 ;Voice setting (0=off, 1=hdg/alt, 2=freq/crs, 3=on)
towarn=1                ;Take-off warn (0=off, 1=on) 
tocall=1                ;Take-off speed calls:    (0=off, 1=on)
    vaa=0               ;    Airspeed active call (0=off, 30, 40, ... kts)
    v1r=5               ;    V1 call kts below VR (0=off, 5, 10, ...kts)
    v2r=0               ;    V2 call kts above VR (0=off, 20, ...kts)
IF ENGINE_TYPE=1        ;Default settings for jet aircraft:
    vr=140              ;    VR call in kts
    cat=3               ;    Aircraft cat (1=A, 2=B, 3=C, 4=D, 5=E)
ELSE                    ;Default settings for other aircraft:
    vr=70               ;    VR call in kts
    cat=2               ;    Aircraft cat (1=A, 2=B, 3=C, 4=D, 5=E)
ENDIF                   ;
    autoland=1          ;    Autoland     (0=off, 1=on)
    autortd=1           ;    Auto retard  (0=off, 1=on)
    autorev=1           ;    Auto reverse (0=off, 1=on)
flch=1                  ;Altitude select  (0=v/s, 1=flch)
gear=cat*2              ;RA correction for gear height (overridden on ground)
belts=belts+(belts=1 AND (FLAPS_LEFT_POSITION>0 OR GEAR_2_POSITION>0))
trim=ELEVATOR_TRIM_POSITION

;IF iClearanceFreq>0                         ;{add for ProFlight98 module}
;    iFreq=iClearanceFreq                    ;{add for ProFlight98 module}
;ELSEIF iGroundOrigFreq>0                    ;{add for ProFlight98 module}
;    iFreq=iGroundOrigFreq                   ;{add for ProFlight98 module}
;ELSEIF iTowerOrigFreq>0                     ;{add for ProFlight98 module}
;    iFreq=iTowerOrigFreq                    ;{add for ProFlight98 module}
;ELSEIF iUnicomFreq>0                        ;{add for ProFlight98 module}
;    iFreq=iUnicomFreq                       ;{add for ProFlight98 module}
;ELSE                                        ;{add for ProFlight98 module}
;    iFreq=iMulticomFreq                     ;{add for ProFlight98 module}
;ENDIF                                       ;{add for ProFlight98 module}
;freqToSay=clr_freq                          ;{add for WinPlanner4 module}
;callRadarAlt=0                              ;{add for WinPlanner4 module}

; Assigning keys *************************************************************
DH_key = KV(SHIFT "d")       ;You can change these keys
GPWS_key = KV(SHIFT "g")     
BANK_key = KV(SHIFT "b")     
TRIM_key = KV(SHIFT "t")     
VOICE_key = KV(SHIFT "v") 
SPDCALL_key = KV(",")
END_key = KV(CTRL "u")       

APHDG_key = KV("`")
APALT_key = KV("\")
DN_key = KV(SHIFT "o")        
UP_key = KV(SHIFT "p") 
L1_key = KV(SHIFT ";")
R1_key = KV(SHIFT "'")       
L10_key = KV(SHIFT ",")       
R10_key = KV(SHIFT ".")       
                            ;Notes
CAT_key = KV("c")            ;(1)      via ADF key       (AC category)
LAND_key = KV("l")           ;         via ADF key       (AL autoland)
RTD_key = KV("e")            ;(1)      via ADF key       (AE auto retard)
REV_key = KV("r")            ;(2)      via ADF key       (AR auto reverse)
			    
ADF_key = KV("a")            ;(2)      also for: CAT, LAND, REV, RTD, TO, FR
COM_key = KV("c")            ;(2)      also for: COM2, RATE
NAV1_key = KV("n")           ;         also for: CRS, TO, FR
NAV2_key = KV("m")           ;         also for: CRS, TO, FR
XPDR_key = KV("t")           ;(2)      

COM2_key = KV("d")           ;(1)      via COM key       (CD)
RATE_key = KV("r")           ;(1)      via COM key       (CR)
CRS_key = KV("c")            ;(1)      via NAV keys      (NC,MC)
TO_key = KV("t")             ;(1)      via NAV/ADF keys  (NT,MT,AT)
FR_key = KV("f")             ;         via NAV/ADF keys  (NF,MF,AF)  
DIST_key= KV("d")            ;(1)      via NAV/ADF keys  (ND,MD,AD)

keyA = KV("a")               ;(1)
keyB = KV("b")         
keyC = KV("c")               ;(1)
keyD = KV("d")               ;(2)
keyE = KV("e")
                   ;KV KEY   Keyboard Scan Codes
key1 = KV("1")     ; 2  49   The 'KV' codes are used to designate a key on
key2 = KV("2")     ; 3  50   on the keyboard, these codes are converted 
key3 = KV("3")     ; 4  51   automatically with the KV() function. 
key4 = KV("4")     ; 5  52   The 'KEY' codes are used to trap keys with the
key5 = KV("5")     ; 6  53   KEY statement in the program. These codes are 
key6 = KV("6")     ; 7  54   also converted automatically with KV() function,
key7 = KV("7")     ; 8  55   however for key0-9 this function is not used in
key8 = KV("8")     ; 9  56   this program, with these keys the 'KEY' codes
key9 = KV("9")     ;10  57   are used directly. So for key0-9 the 'KEY' codes
key0 = KV("0")     ;11  48   need to stay the same (48-57). 

;Notes
; (1) You can change this key but you need to edit the 'Temporary keys
;     procedures' below: activate this key in the two procedures.
; (2) You can change this key but you need to edit the 'Temporary keys
;     procedures' below: in these procedures there is another key deactivated
;     which did use the same KV(), you need to activate that key otherwise
;     it will not function anymore.
; Changing more than one of these keys can be tricky because of all possible
; combinations!

; Temporary keys procedures **************************************************
DEFINE PROCEDURE keys_add()
    WAIT 0,KEYPRESS
    ADV_KEYS ADD, key1, key2, key3, key4, key5, key6, key7, key8, key9, key0
    ADV_KEYS ADD, keyB, keyD, keyE, FR_key, LAND_key, REV_key 
    ; ADV_KEYS ADD,
    ; keyA, keyC, CAT_key, COM2_key, CRS_key, DIST_key, RATE_key, RTD_key, TO_key
    ;   These keys are deactivated because they are double (already added
    ;   here or below), if you change a key you may need to add one of these.
    APL_SOUND=1
    PLAY "-ss1"
    swap=0
ENDDEFINE

DEFINE PROCEDURE keys_del()                    
    ADV_KEYS DELETE, key1, key2, key3, key4, key5, key6, key7, key8, key9, key0
    ADV_KEYS DELETE, keyB, keyD, keyE, FR_key, LAND_key, REV_key 
    ; ADV_KEYS DELETE,
    ; keyA, keyC, CAT_key, COM2_key, CRS_key, DIST_key, RATE_key, RTD_key, TO_key
    ;   These keys are deactivated because they are double (already added
    ;   here or below), if you change a key you may need to use one of these.
    WAIT 0,KEYPRESS
ENDDEFINE                        

; Adding keys **************************************************************** 
ADV_KEYS ADD, DH_key, GPWS_key, BANK_key, TRIM_key, VOICE_key, SPDCALL_key, END_key
ADV_KEYS ADD, APHDG_key, APALT_key, DN_key, UP_key, L1_key, R1_key, L10_key, R10_key
ADV_KEYS ADD, NAV1_key, NAV2_key, ADF_key, COM_key, XPDR_key
						  
ONKEY ADF_key GOSUB adf
ONKEY COM_key GOSUB com
ONKEY NAV1_key GOSUB nav1          
ONKEY NAV2_key GOSUB nav2                   ;{delete for ProFlight98 module}

ONKEY APHDG_key GOSUB ap_hdg                ;{delete option for ProFlight98}
ONKEY APALT_key GOSUB ap_alt                ;{delete option for ProFlight98}
ONKEY DH_key GOSUB set_dh                   ;{delete for ProFlight98 module}
ONKEY GPWS_key GOSUB set_gpws               ;{delete for ProFlight98 module}
ONKEY BANK_key GOSUB set_bankangle          ;{delete for ProFlight98 module}
ONKEY TRIM_key GOSUB set_trimsound          ;{delete for ProFlight98 module}
ONKEY VOICE_key GOSUB set_voice             ;{delete for ProFlight98 module}
ONKEY SPDCALL_key GOSUB set_spdcall         ;{delete for ProFlight98 module}

ONKEY DN_key GOSUB alt_dn                   ;{delete for ProFlight98 module}
ONKEY UP_key GOSUB alt_up                   ;{delete for ProFlight98 module}
ONKEY L1_key GOSUB hdg_l1                   ;{delete for ProFlight98 module}
ONKEY R1_key GOSUB hdg_r1                   ;{delete for ProFlight98 module}
ONKEY L10_key GOSUB hdg_l10                 ;{delete for ProFlight98 module}
ONKEY R10_key GOSUB hdg_r10                 ;{delete for ProFlight98 module}
ONKEY XPDR_key GOSUB xpdr                   ;{delete for ProFlight98 module}
ONKEY END_key GOSUB gpws_end                ;{delete for ProFlight98 module}
							   
; Event monitors *************************************************************
PRINT_TIME 4
GOSUB hal9000                               ;{delete for module}
PLAY "-ss1"
WAIT .1
GOSUB belts_auto
;GOSUB com2_change                           ;{add for module}
GOSUB com_change                            ;{delete for module}
ONEXP_CHANGE COM_FREQ GOSUB com_change      ;{delete for ProFlight98 module}
ONEXP_CHANGE AUTOPILOT_MASTER GOSUB ap_disc

; Common procedures **********************************************************
DEFINE PROCEDURE dplay(digit)
    PLAY_GROUP "fs_$", digit, 10
ENDDEFINE

DEFINE PROCEDURE d1play(digit)
    IF digit>0
        PLAY_GROUP "fs_$", digit, 10
    ENDIF
ENDDEFINE

DEFINE PROCEDURE dgplay(degr)
    IF degr<1
        degr=360
    ENDIF
    dplay(degr IDIV 100)
    dplay((degr/10) IREM 10)
    dplay(degr IREM 10)
ENDDEFINE

DEFINE PROCEDURE on_gnd()                             ;RA correction
;    IF INRANGE(PLANE_ALT-GROUND_ALTITUDE,0,6) AND ON_GROUND             ;[m] 
;        gear=MTOF(PLANE_ALT-GROUND_ALTITUDE)                            ;[m]
    IF INRANGE(PLANE_ALT-GROUND_ALTITUDE,0,20) AND ON_GROUND            ;[-a]
        gear=PLANE_ALT-GROUND_ALTITUDE                                  ;[-a]
    ENDIF
ENDDEFINE

DEFINE PROCEDURE ra()                                 ;Radio Altitude
;    ra=MTOF(PLANE_ALT-GROUND_ALTITUDE)-gear                             ;[m]
    ra=PLANE_ALT-GROUND_ALTITUDE-gear                                   ;[-a]
ENDDEFINE

DEFINE PROCEDURE timer(start_time)
    time=60*MINUTE+SECOND-start_time
    IF time<0                                   
        time=time+3600
    ENDIF
ENDDEFINE

DEFINE FUNCTION timer_start()
    RETURN 60*MINUTE+SECOND
ENDDEFINE

;-----------------------------------------------------------------------------
; GPWS main program
;-----------------------------------------------------------------------------
gpws:
    ias0=ias
    ias=VELOCITY_INDICATED                            ;Indicated Airspeed
    ra()                                              ;Radio Altitude
    IF ON_GROUND
        timer(tdtime)                                 ;touchdown timer
        IF THROTTLE_1>.7 AND time>9                   ;go around: no warn/call
;            IF (NOT INRANGE(ELEVATOR_TRIM_POSITION,-8000,8000) OR NOT INRANGE(FLAPS_LEFT_POSITION,3300,22000) OR PARKING_BRAKES) AND towarn>0  ;[m]
            IF (NOT INRANGE(ELEVATOR_TRIM_POSITION,-.5,.5) OR NOT INRANGE(FLAPS_LEFT_POSITION,.1,.67) OR PARKING_BRAKES) AND towarn>0          ;[-a]
                PLAY ""
                PLAY "-towarn"                        ;take-off config warning
                WAIT 1.6
                GOTO gpws
            ELSEIF tocall
                GOSUB to_calls                        ;take-off calls
            ENDIF
        ELSEIF THROTTLE_1<.1 AND ((reverse=1 AND time>2) OR (ias>80 AND BRAKE_LEFT_POSITION>0))
            ONEXP_TRUE THROTTLE_1>.1 GOSUB auto_restow
            auto_reverse(0)                           ;land/rto: idle reverse
            time_ongnd(3)                             ;time on ground
            GOSUB pitch_ongnd                         ;nose gear on ground
            auto_reverse(.95)                         ;full reverse
        ELSEIF reverse=2 AND ias<63                   
            auto_reverse2()                           ;reduce reverse
            GOSUB auto_restow
        ENDIF
        on_gnd()
    ELSEIF INRANGE(ra,30,2450) 
        IF ias0-ias>9 AND INRANGE(ias,1,180) AND ra<1500 AND PLANE_PITCH<25 
;            x1=(WIND_SURF_VEL>10 AND INRANGE(MTOF(WIND_SURF_DEPTH)-ra,-200,200)) OR (WIND_LOW_VEL>10 AND (INRANGE(MTOF(WIND_LOW_BASE)-ra,-200,200) OR INRANGE(MTOF(WIND_LOW_TOP)-ra,-200,200)))                                               ;[m]
;            x1=x1 OR (WIND_MID_VEL>10 AND (INRANGE(MTOF(WIND_MID_BASE)-ra,-200,200) OR INRANGE(MTOF(WIND_MID_TOP)-ra,-200,200))) OR (WIND_UP_VEL>10 AND (INRANGE(MTOF(WIND_UP_BASE)-ra,-200,200) OR INRANGE(MTOF(WIND_UP_TOP)-ra,-200,200)))  ;[m]
            x1=(WIND_SURF_VEL>10 AND INRANGE(WIND_SURF_DEPTH-ra,-200,200)) OR (WIND_LOW_VEL>10 AND (INRANGE(WIND_LOW_BASE-ra,-200,200) OR INRANGE(WIND_LOW_TOP-ra,-200,200)))                                                                 ;[-a]
            x1=x1 OR (WIND_MID_VEL>10 AND (INRANGE(WIND_MID_BASE-ra,-200,200) OR INRANGE(WIND_MID_TOP-ra,-200,200))) OR (WIND_UP_VEL>10 AND (INRANGE(WIND_UP_BASE-ra,-200,200) OR INRANGE(WIND_UP_TOP-ra,-200,200)))                          ;[-a]
            IF x1 AND gpws>1              
                PLAY ""
                PLAY "-windshr"                       ;mode7 windshear
                WAIT 3
                ias=VELOCITY_INDICATED
                GOTO gpws
            ENDIF
        ENDIF
;        vs=VELOCITY_Y*196.8                           ;vert spd m/s     ;[m]
        vs=VELOCITY_Y                                 ;vert spd ft/min  ;[-a]
        IF vs<100 
            IF ra<1000 
                IF vs<-1.2*ra-1000 AND gpws>1         
                    IF vs<-1.2*ra-2000
                        GOTO gpws_terrain             ;mode2
                    ELSEIF vs<-1.8*ra-1400
                        GOTO gpws_pullup              ;mode1
                    ELSE
                        GOTO gpws_sinkrate            ;mode1
                    ENDIF                      
                ELSEIF GEAR_2_POSITION=0 AND (ra<500 OR ias>.12*ra+130) AND sinkalt=0 AND gpws>2
                    GOSUB altcall_off                 ;alt call monitor off
                    gpwsmode=4                        ;mode4a gear
                    PLAY ""                           ;cut off sounds
                    IF ias>190
                        PLAY "-toolowt"               
                    ELSE
                        PLAY "-gear"                  
                    ENDIF
                    WAIT 2
                    GOTO gpws
;                ELSEIF FLAPS_LEFT_POSITION<21500 AND (ra<245 OR ias>.12*ra+130) AND sinkalt=0 AND gpws>3  ;[m]
                ELSEIF FLAPS_LEFT_POSITION<.66 AND (ra<245 OR ias>.12*ra+130) AND sinkalt=0 AND gpws>3    ;[-a]
                    GOSUB altcall_off             
                    gpwsmode=4                        ;mode4b flaps <20
                    PLAY ""                       
                    IF ias>159
                        PLAY "-toolowt"               
                    ELSE
                        PLAY "-flaps"                 
                    ENDIF
                    WAIT 2
                    GOTO gpws
                ELSEIF VOR_1_GS_AVAIL AND VOR_1_GS_DEVIATION>.65 AND (ra>150 OR VOR_1_GS_DEVIATION>.65+(150-ra)/170) AND (ra<500 OR INRANGE(VOR_1_COURSE_DEVIATION,-.999,.999)) AND gpws>4
                    IF gpwsmode!=5                    ;<150ft less sensitive
                        gpwsmode=5                    ;mode5 glide slope
                        PLAY ""                       
                    ENDIF
                    PLAY "-gs"                        
                    WAIT .003*ra/VOR_1_GS_DEVIATION+.8
                    GOTO gpws  
                ENDIF
                GOSUB autoland                        ;autoland
            ELSEIF vs<-1.9*ra-300 AND gpws>1          ;RA >1000ft
                IF vs<-4.5*ra+1300                
                    GOTO gpws_terrain                 ;mode2
                ELSEIF vs<-2.6*ra-600
                    GOTO gpws_pullup                  ;mode1
                ELSE
                    GOTO gpws_sinkrate                ;mode1
                ENDIF                      
            ENDIF
;        ELSEIF ra<245 AND (GEAR_2_POSITION=0 OR FLAPS_LEFT_POSITION<21500)  ;[m]
        ELSEIF ra<245 AND (GEAR_2_POSITION=0 OR FLAPS_LEFT_POSITION<.66)    ;[-a]
            sinkalt=1             ;mode3 arm (take-off / go-around <245ft
        ENDIF                     ;           with gear or flaps raised)
        IF sinkalt>0
;            IF (ra>700 AND ias<190) OR ra>1333 OR (GEAR_2_POSITION>0 AND FLAPS_LEFT_POSITION>22000)  ;[m]
            IF (ra>700 AND ias<190) OR ra>1333 OR (GEAR_2_POSITION>0 AND FLAPS_LEFT_POSITION>.67)    ;[-a]
                sinkalt=0                             ;mode3 disarm
            ELSEIF PLANE_ALT>sinkalt 
                sinkalt=PLANE_ALT
;            ELSEIF sinkalt-PLANE_ALT>ra/33 AND gpws>1                   ;[m]
            ELSEIF sinkalt-PLANE_ALT>ra/10 AND gpws>1                   ;[-a]
                IF gpwsmode!=3                        
                    gpwsmode=3                        ;mode3 don't sink
                    PLAY ""                       
                ENDIF
                PLAY "-dontsnk"                       
                WAIT 1.5
                GOTO gpws  
            ENDIF
        ENDIF
    ENDIF                    
    gpwsmode=0                                        ;reset warnings
    ra()
    IF ra>lastcall*1.03+20 AND VELOCITY_Y<0
        GOSUB altcall_off                             ;reset mode6 alt calls
        GOSUB altcall_on  
    ENDIF
    IF NOT INRANGE(PLANE_BANK,-10,10) AND (NOT INRANGE(PLANE_BANK,-bankangle,bankangle) OR NOT INRANGE(PLANE_BANK,-.25*ra-2.5,.25*ra+2.5)) AND bankangle>0 AND gpws>1
        x1=PLANE_BANK                                 
        IF x1<0
            x1=-x1
        ENDIF
        IF x1>bank OR x1>bankangle+10 OR (ra<130 AND x1>.36*ra+3.6)
            PLAY ""
            PLAY "-bnkangl"                           ;mode6 bank angle
            IF ra>130
                WAIT 1.5                              ;<130ft no pause
            ENDIF
            PLAY "-bnkangl"
            WAIT 1.5
            IF bank<x1*1.14
                bank=x1*1.14                          ;increase limit
            ENDIF
        ENDIF
    ELSEIF bank>0
        bank=0                                        ;reset mode6 bank angle
    ENDIF                    
;    GOSUB gpws_inkey         ;{add for module}        ;backup key input
    GOSUB alt_alert                                   ;altitude alert
    GOSUB airspd_calls                                ;airspeed calls
    GOSUB atc_play                                    ;random ATC and ATIS
    GOSUB trim                                        ;trim
;    aplrate=aplrate+1                       ;{add for module}
;    IF aplrate<10-com1rate OR com1rate=0    ;{add for module}   
        GOTO gpws       
;    ENDIF                                   ;{add for module}
;    aplrate=0                               ;{add for module}
;    RETURN                                  ;{add for module}

;-----------------------------------------------------------------------------
; GPWS subroutines
;-----------------------------------------------------------------------------
gpws_end:
    PLAY ""
    PLAY "-ss1"
    ADV_KEYS CLEAR
    END

gpws_input:
    trim=ELEVATOR_TRIM_POSITION
gpws_inkey:                                           
    WAIT 0                   
    val=KEY                 
    IF val=0
        RETURN
    ENDIF
gpws_inkey2:                                          ;backup key input
    IF val=APHDG_key
        GOTO ap_hdg         
    ELSEIF val=APALT_key             
        GOTO ap_alt         
    ELSEIF val=DN_key
        GOSUB alt_dn
    ELSEIF val=UP_key
        GOSUB alt_up
    ELSEIF val=L1_key
        GOSUB hdg_l1
    ELSEIF val=R1_key
        GOSUB hdg_r1
    ELSEIF val=L10_key
        GOSUB hdg_l10
    ELSEIF val=R10_key
        GOSUB hdg_r10
    ELSEIF val=DH_key             
        GOSUB set_dh         
    ELSEIF val=GPWS_key      
        GOSUB set_gpws
    ELSEIF val=BANK_key
        GOSUB set_bankangle
    ELSEIF val=TRIM_key
        GOSUB set_trimsound
    ELSEIF val=VOICE_key
        GOSUB set_voice
    ELSEIF val=SPDCALL_key
        GOSUB set_spdcall
    ELSEIF val=XPDR_key
        GOTO xpdr
    ELSEIF val=END_key
        GOTO gpws_end
    ELSE
        trim=ELEVATOR_TRIM_POSITION
        RETURN
    ENDIF
    WAIT 0,KEYPRESS
    WAIT 0,KEYPRESS
    WAIT 2,KEYPRESS
    val=KEY                 
    GOTO gpws_inkey2

gpws_pullup:                                          
    IF gpwsmode=1
        GOSUB altcall_off                             
        PLAY "-pullup"                                ;mode1 pull up
        WAIT 1.2
        GOTO gpws
    ENDIF
gpws_sinkrate:                                        
    IF gpwsmode!=1
        gpwsmode=1                                    ;mode1 sink rate
        PLAY ""                                       
    ENDIF
    PLAY "-snkrate"
    WAIT 1.5
    GOTO gpws  

gpws_terrain:                                         
    IF gpwsmode!=2 
        GOSUB altcall_off                             
        PLAY ""                                       
        gpwsmode=2                                    ;mode2a+b terrain
        PLAY "-terrain"                               
        WAIT 1.2
        PLAY "-terrain"
    ELSEIF GEAR_2_POSITION>0 AND FLAPS_LEFT_POSITION>.67
        PLAY "-terrain"                               ;mode2a+b terrain
    ELSE
        PLAY "-pullup"                                ;mode2a pull up
    ENDIF
    WAIT 1.2
    GOTO gpws 

;-----------------------------------------------------------------------------
; GPWS test / APL rate
;-----------------------------------------------------------------------------
hal9000:
    IF RANDOM<.8 OR HOUR<3
        PRINT "SYSTEMS READY"
    ELSEIF HOUR<10
        PRINT "SYSTEMS READY, GOOD MORNING"
    ELSEIF HOUR<18
        PRINT "SYSTEMS READY, GOOD DAY"
    ELSE
        PRINT "SYSTEMS READY, GOOD EVENING"
    ENDIF
    RETURN

set_aplrate:
    PRECISION 3,0,0
    GOSUB test_aplrate                                ;reset timer
    GOSUB test_aplrate                                ;test apl rate
    x1=INT(perf_high*aplrate_min/aplrate)
    IF NOT INRANGE(x1-perf_high,-2,2)
        perf_high=x1
        GOTO set_aplrate
    ENDIF
    WHILE aplrate>aplrate_min
        perf_high=perf_high-1
        GOSUB test_aplrate
    ENDWHILE
    WHILE aplrate<aplrate_min
        perf_high=perf_high+1
        GOSUB test_aplrate
    ENDWHILE
    RETURN

set_aplrate_min:
    PRECISION 3,0,0
    PRINT_TIME 20
    PRINT
    PRINT "RTMIN/RATE/PERF ",aplrate_min,aplrate,perf_high
    WAIT 4,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,49,57)
        PLAY "-ss1"
        aplrate_min=val-48
        PRINT "RTMIN/RATE/PERF ",aplrate_min,aplrate,perf_high
        WAIT 4,KEYPRESS
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57)
            PLAY "-ss1"
            aplrate_min=aplrate_min*10+val-48
            PRINT "RTMIN/RATE/PERF ",aplrate_min,aplrate,perf_high
            WAIT 4,KEYPRESS
            val=KEY
            IF INRANGE(val,48,57) 
                aplrate_min=aplrate_min*10+val-48
            ENDIF
        ENDIF
    ENDIF
    PLAY "-ss1"
    PRINT "TESTING SYSTEMS ",aplrate_min,aplrate,perf_high
    keys_del()
    IF perf_high<1
        perf_high=1
    ENDIF    
    GOSUB set_aplrate
    PRINT_TIME 8
    PLAY "-ss1"
    PRINT "TESTING SYSTEMS ",aplrate_min,aplrate,perf_high," - GPWS OK"
    PRINT_TIME 4
    WAIT 8,KEYPRESS
    GOTO gpws_input

test_aplrate:
    IF perf_high>0
        PERFORMANCE HIGH perf_high
    ELSEIF perf_high=0
        PERFORMANCE MEDIUM 1
    ELSEIF perf_high=-1
        PERFORMANCE LOW 1
    ELSE
        PRINT "!SYSTEM FAILURE ",aplrate_min,aplrate,perf_high," - RESTART FS98"
        PLAY "-ss2"
        WAIT 20
        END
    ENDIF
    aplrate=0
    time=0
    x1=FUNCTION timer_start()
    WHILE time<1
        aplrate=aplrate+1
        timer(x1)  
    ENDWHILE
    PRINT "TESTING SYSTEMS ",aplrate_min,aplrate,perf_high  ;{delete for module}
    RETURN

;-----------------------------------------------------------------------------
; Altitude calls
;-----------------------------------------------------------------------------
altcall_off:                                          ;mode6 alt monitor off
    IF lastcall<20
        RETURN
    ELSEIF lastcall<50
        ONEXP_CLEAR call10
        ONEXP_CLEAR call20
        ONEXP_CLEAR call30
    ELSEIF lastcall<200
        ONEXP_CLEAR call40
        ONEXP_CLEAR call50
        ONEXP_CLEAR call100
    ELSEIF lastcall<580
        ONEXP_CLEAR call130
        ONEXP_CLEAR call200
        ONEXP_CLEAR call300
        ONEXP_CLEAR call400
    ELSE
        ONEXP_CLEAR call500
        ONEXP_CLEAR call580
        ONEXP_CLEAR call1000
        ONEXP_CLEAR call2500
    ENDIF 
    lastcall=-99
    ONEXP_TRUE ON_GROUND GOSUB call0
    RETURN

altcall_on:                                           ;mode6 set alt monitor
    IF gpws=0                                         ;GPWS OFF: no alt calls
        lastcall=60000
        RETURN
    ENDIF
    ONEXP_CLEAR call0
    IF ra<50
        ON ra/10 GOSUB alt0, alt10, alt20, alt30, alt40
    ELSEIF ra<580
        ON ra/100 GOSUB alt50, alt100, alt200, alt300, alt400, alt500
    ELSEIF ra<1000
        GOSUB alt580
    ELSEIF ra<2500
        GOSUB alt1000
    ELSE
        GOSUB alt2500
    ENDIF
    RETURN

alt2500:
    lastcall=60000
;    altcall=FTOM(2510+gear)                                             ;[m]
    altcall=2510+gear                                                   ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call2500
    RETURN
call2500:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""              ;{delete for module}
        PLAY "-2500"
        WAIT 1.3
    ENDIF
    ONEXP_CLEAR call2500
alt1000:
    lastcall=2500
;    altcall=FTOM(1010+gear)                                             ;[m]
    altcall=1010+gear                                                   ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call1000
    RETURN
call1000:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""              ;{delete for module}
        PLAY "-1000"
        WAIT .9
    ENDIF
    ONEXP_CLEAR call1000
alt580:
    lastcall=1000
;    altcall=FTOM(585+gear)                                              ;[m]
    altcall=585+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call580
    RETURN
call580:
    IF dh=500 AND PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        PLAY "-apprmin"
    ENDIF
    ONEXP_CLEAR call580
alt500:
    lastcall=580
;    altcall=FTOM(505+gear)                                              ;[m]
    altcall=505+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call500
    RETURN
call500:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        IF dh=500
            PLAY "-min"
        ELSE
            PLAY "-500"          
            IF dh=400
                PLAY "-apprmin"
            ENDIF
        ENDIF 
    ENDIF
    ONEXP_CLEAR call500
alt400:
    lastcall=500
;    altcall=FTOM(405+gear)                                              ;[m]
    altcall=405+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call400
    RETURN
call400:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        IF dh=400
            PLAY "-min"
        ELSE
            PLAY "-400"          
            IF dh=300
                PLAY "-apprmin"
            ENDIF
        ENDIF 
    ENDIF
    ONEXP_CLEAR call400
alt300:
    lastcall=400
;    altcall=FTOM(305+gear)                                              ;[m]
    altcall=305+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call300
    RETURN
call300:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        IF dh=300
            PLAY "-min"
        ELSE
            PLAY "-300"          
            IF dh=200
                PLAY "-apprmin"
            ENDIF
        ENDIF 
    ENDIF
    ONEXP_CLEAR call300
alt200:
    lastcall=300
;    altcall=FTOM(205+gear)                                              ;[m]
    altcall=205+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call200
    RETURN
call200:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        IF dh=200
            PLAY "-min"
        ELSE
            PLAY "-200"          
            IF dh=100
                PLAY "-apprmin"
            ENDIF
        ENDIF 
    ENDIF
    ONEXP_CLEAR call200
alt130:
    lastcall=200
;    altcall=FTOM(135+gear)                                              ;[m]
    altcall=135+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call130
    RETURN
call130:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        IF dh=50
            PLAY "-apprmin"
        ENDIF
    ENDIF
    ONEXP_CLEAR call130
alt100:
    lastcall=130
;    altcall=FTOM(105+gear)                                              ;[m]
    altcall=105+gear                                                    ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call100
    RETURN
call100:
    IF PLANE_ALT-GROUND_ALTITUDE>altcall-20
        APL_SOUND=1
        PLAY ""
        IF dh=100
            PLAY "-min"
        ELSE
            PLAY "-100"          
            IF dh=20
                PLAY "-apprmin"
            ENDIF
        ENDIF 
    ENDIF
    ONEXP_CLEAR call100
alt50:
    lastcall=100
;    altcall=FTOM(55+gear)                                               ;[m]
    altcall=55+gear                                                     ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call50
    RETURN
call50:
    APL_SOUND=1
    PLAY ""
    IF dh=50
        PLAY "-min"
    ELSE
        PLAY "-50"          
    ENDIF 
    ONEXP_CLEAR call50
alt40:
    lastcall=50
;    altcall=FTOM(45+gear)                                               ;[m]
    altcall=45+gear                                                     ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call40
    RETURN
call40:
    PLAY ""
    PLAY "-40"          
    ONEXP_CLEAR call40
alt30:
    lastcall=40
;    altcall=FTOM(35+gear)                                               ;[m]
    altcall=35+gear                                                     ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call30
    RETURN
call30:
    PLAY ""
    PLAY "-30"          
    ONEXP_CLEAR call30
alt20:
    lastcall=30
;    altcall=FTOM(25+gear)                                               ;[m]
    altcall=25+gear                                                     ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call20
    RETURN
call20:
    PLAY ""
    IF dh=20
        PLAY "-min"
    ELSE
        PLAY "-20"          
    ENDIF 
    ONEXP_CLEAR call20
alt10:
    lastcall=20
;    altcall=FTOM(15+gear)                                               ;[m]
    altcall=15+gear                                                     ;[-a]
    ONEXP_TRUE PLANE_ALT-GROUND_ALTITUDE<altcall GOSUB call10
    RETURN
call10:
    PLAY ""
    PLAY "-10"          
    ONEXP_CLEAR call10
alt0:
    lastcall=10
    ONEXP_TRUE ON_GROUND GOSUB call0
    RETURN
call0:                                                ;touchdown
    ONEXP_CLEAR call0
    IF gpws>1                                         ;reset g/s-inhibit
        gpws=5                                        ;      flap-inhibit
    ENDIF                                             ;      gear-inhibit
    lastcall=0
    reverse=1                                         ;enable auto reverse
    spdcall=0                                         ;reset spd calls
    tdtime=FUNCTION timer_start()                     ;touchdown time
    RETURN

;-----------------------------------------------------------------------------
; Altitude Alert
;-----------------------------------------------------------------------------
alt_alert:
    IF AUTOPILOT_ALTITUDE>0
;        altdev=MTOF(AUTOPILOT_ALTITUDE-PLANE_ALT)                       ;[m]
        altdev=AUTOPILOT_ALTITUDE-PLANE_ALT                             ;[-a]
        IF alertalt=AUTOPILOT_ALTITUDE       
            IF INRANGE(altdev,-900,900)                  
                IF INRANGE(altdev,-200,200)        
                    altalert=0
                ELSEIF altalert=0                     ;deviation 200-900ft
                    GOSUB alt_arm                     ;200ft exit alert or
                    GOTO play_altalert                ;900ft entry alert
                ENDIF
            ELSEIF altalert>0 
                IF altalert=2                         ;after 900ft entry:
                    altalert=1                        ;    900ft exit alert
                    GOSUB play_altalert               ;(avoid double alert
                ENDIF                                 ; 200ft + 900ft exit)
                altalert=0                            
            ENDIF                                     
        ELSEIF alertalt=-AUTOPILOT_ALTITUDE 
            alertalt=-alertalt
            IF INRANGE(altdev,-900,900)               ;within 900ft
                GOTO alt_arm                          ;no alert
            ELSE
                altalert=0
            ENDIF
        ELSE
            alertalt=-AUTOPILOT_ALTITUDE              ;delay
        ENDIF
    ENDIF
    RETURN

alt_arm:
    IF altdev/VELOCITY_Y<0                            ;exit from 200ft
        altalert=1                                           
    ELSE                                              ;entry within 900ft:
        altalert=2                                    ;      arm exit warn
    ENDIF
    RETURN

play_altalert:
;    IF FLAPS_LEFT_POSITION<25000 AND NOT (VOR_1_GS_AVAIL AND INRANGE(VOR_1_GS_DEVIATION,-.2,.2))  ;[m]
    IF FLAPS_LEFT_POSITION<.76 AND NOT (VOR_1_GS_AVAIL AND INRANGE(VOR_1_GS_DEVIATION,-.2,.2))    ;[-a]
        PLAY ""              ;{delete for module}
        IF altalert=1
            PLAY "-altalrt"
            WAIT .7
        ELSE
            PLAY "-altentr"
            WAIT 1
        ENDIF
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; AP disconnect and Trim
;-----------------------------------------------------------------------------
ap_disc:
    IF AUTOPILOT_MASTER=0 
        APL_SOUND=1
        PLAY ""              ;{delete for module}
        PLAY "-apdisco"
        WAIT .7
        trim=ELEVATOR_TRIM_POSITION
    ENDIF
    RETURN

trim:
;    IF trim!=ELEVATOR_TRIM_POSITION AND (AUTOPILOT_MASTER=0 OR (NOT INRANGE(trim-ELEVATOR_TRIM_POSITION,-1677,1677) AND trimsound>1)) AND trimsound>0  ;[m]
    IF trim!=ELEVATOR_TRIM_POSITION AND (AUTOPILOT_MASTER=0 OR (NOT INRANGE(trim-ELEVATOR_TRIM_POSITION,-.1,.1) AND trimsound>1)) AND trimsound>0      ;[-a]
        PLAY "-trim"
        WAIT .4
        trim=ELEVATOR_TRIM_POSITION
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; Settings
;-----------------------------------------------------------------------------
set_dh:
    PRINT_TIME 3
    PRINT
    PLAY "-ss1"
    IF dh=0
        PRINT "DH 20"
        dh=20
    ELSEIF dh=20 
        PRINT "DH 50"
        dh=50
    ELSEIF dh=50 
        PRINT "DH 100"
        dh=100
    ELSEIF dh=100 
        PRINT "DH 200"
        dh=200
    ELSEIF dh=200 
        PRINT "DH 300"
        dh=300
    ELSEIF dh=300 
        PRINT "DH 400"
        dh=400
    ELSEIF dh=400 
        PRINT "DH 500"
        dh=500
    ELSE
        PRINT "DH OFF"
        dh=0
    ENDIF
    RETURN

set_gpws:
    PRINT_TIME 3
    PRINT
    PLAY "-ss1"
    IF gpws=0
        PRINT "GPWS ON"
        gpws=5
        lastcall=0
        sinkalt=0
    ELSEIF gpws=5
        PRINT "GPWS g/s-inhb"
        gpws=4
    ELSEIF gpws=4
        PRINT "GPWS flap-ovrd"
        gpws=3
    ELSEIF gpws=3
        PRINT "GPWS gear-ovrd"
        gpws=2
    ELSEIF gpws=2
        PRINT "GPWS alt-only"
        gpws=1
    ELSE
        PRINT "GPWS OFF"
        lastcall=0
        gpws=0
    ENDIF
    RETURN

set_bankangle:
    PRINT_TIME 3
    PRINT
    PLAY "-ss1"
    IF bankangle=0
        PRINT "BANK ANGLE 65"
        bankangle=65
    ELSEIF bankangle=65
        PRINT "BANK ANGLE 50"
        bankangle=50
    ELSEIF bankangle=50
        PRINT "BANK ANGLE 35"
        bankangle=35
    ELSE
        PRINT "BANK ANGLE OFF"
        bankangle=0
    ENDIF
    RETURN

set_trimsound:
    PRINT_TIME 3
    PRINT
    PLAY "-ss1"
    IF trimsound=0
        PRINT "TRIM SOUND ON"
        trimsound=2
    ELSEIF trimsound=2
        PRINT "TRIM SOUND manual-only"
        trimsound=1
    ELSE
        PRINT "TRIM SOUND OFF"
        trimsound=0
    ENDIF
    RETURN

set_voice:
    PRINT_TIME 3
    PRINT
    PLAY "-ss1"
    IF voice=3
        PRINT "VOICE OFF"
        voice=0
    ELSEIF voice=0
        PRINT "VOICE hdg/alt-only"
        voice=1
    ELSEIF voice=1
        PRINT "VOICE freq/crs-only"
        voice=2
    ELSE
        PRINT "VOICE ON"
        voice=3
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; Take-off config and Radio Altitude
;-----------------------------------------------------------------------------
to_config:
    x2=0
    PRINT_TIME 3
    PRINT 
    IF PARKING_BRAKES
        PRINT "PARKING BRAKE",
        x2=1
    ENDIF
;    IF NOT INRANGE(ELEVATOR_TRIM_POSITION,-8000,8000)                   ;[m]
    IF NOT INRANGE(ELEVATOR_TRIM_POSITION,-.5,.5)                       ;[-a]
        IF x2=1
            PRINT " - ",
        ENDIF
        PRINT "STABILIZER",
        x2=1
    ENDIF
;    IF NOT INRANGE(FLAPS_LEFT_POSITION,3300,22000)                      ;[m]
    IF NOT INRANGE(FLAPS_LEFT_POSITION,.1,.67)                          ;[-a]
        IF x2=1
            PRINT " - ",
        ENDIF
        PRINT "FLAPS",
        x2=1
    ENDIF
    IF x2=0
        PRINT "TAKE-OFF CONFIG OK",
    ENDIF
    PRINT ""
    set_towarn:
    WAIT 3,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS
    IF val=XPDR_key
        PLAY "-ss1"
        IF towarn
            PRINT "TAKE-OFF WARNING OFF"
            towarn=0
        ELSE
            PRINT "TAKE-OFF WARNING ON"
            towarn=1
        ENDIF
        GOTO set_towarn
    ENDIF
    PRINT_TIME 0
    PRINT
    PRINT_TIME 3
    keys_del()
    RETURN

ra_play:
    keys_del()
    ra()
    PLAY ""                  ;{delete for module}
    IF ra<1000
        d1play(ra IDIV 100)
        IF ra IDIV 100 >0 AND (ra/10) IREM 10 =0
            PLAY "fshund"
        ELSE
            d1play((ra/10) IREM 10)
            PLAY "fs_0"
        ENDIF
    ELSE
        alt=ra/100+.4
        d1play(alt IDIV 100) 
        dplay((alt/10) IREM 10) 
        PLAY "fsthous"
        IF alt IREM 10 >0
            dplay(alt IREM 10) 
            PLAY "fshund"
        ENDIF
    ENDIF
    WAIT 2,KEYPRESS
    GOTO gpws_input

;-----------------------------------------------------------------------------
; Airspeed calls and Take-off calls
;-----------------------------------------------------------------------------
airspd_calls:
    IF spdcall=1                                      ;speed calls
        timer(spdtime)
        IF time>4 AND NOT INRANGE(spd-VELOCITY_INDICATED,-7,7) AND INRANGE(ias-VELOCITY_INDICATED,-7,7)
            PLAY ""          ;{delete for module}
            PLAY "fsrc06"
            spd=((5-4*ias+5*VELOCITY_INDICATED) IDIV 10)*10
            d1play(spd IDIV 100)
            IF spd IDIV 100 >0 AND (spd IREM 100)/10 =0
                PLAY "fshund"
            ELSE
                d1play((spd IREM 100)/10)
                PLAY "fs_0"
            ENDIF
            spdtime=FUNCTION timer_start()
            WAIT 1.7
        ENDIF
    ENDIF
    RETURN

to_calls:
    IF ias>vr/2 AND time<30             
        tospd=3                                       ;touch and go: VR only
    ENDIF
    x1=vr/70+1
    WHILE ON_GROUND AND (THROTTLE_1>.7 OR VELOCITY_INDICATED>ias)
        ias=VELOCITY_INDICATED
        IF tospd<1 AND INRANGE(VELOCITY_INDICATED,vaa,vaa+10) AND vaa<vr-10 AND vaa
            PLAY ""
            PLAY "p365"                               ;"airspeed active"
            WAIT 1
            tospd=1
        ELSEIF tospd<2 AND INRANGE(VELOCITY_INDICATED+x1,80,90) AND vr>=90
            PLAY ""
            PLAY "p270"                               ;"eighty knots"
            WAIT .7
            tospd=2
        ELSEIF tospd<3 AND INRANGE(VELOCITY_INDICATED+x1,vr-v1r,vr+5) AND v1r    
            PLAY ""
            PLAY "p271"                               ;"V1"  
            WAIT .6
            tospd=3
        ELSEIF tospd=3 AND INRANGE(VELOCITY_INDICATED+x1,vr,vr+10)     
            PLAY ""
            PLAY "p272"                               ;"Rotate" (VR) 
            WAIT .6
            tospd=4
            ONEXP_TRUE NOT INRANGE(VELOCITY_INDICATED,vr-10,vr+v2r) GOSUB v2
        ENDIF
    ENDWHILE
    tospd=0
    RETURN

v2:
    IF VELOCITY_INDICATED>vr AND v2r
        PLAY ""
        PLAY "p367"                                   ;"V2"
        WAIT .6
    ENDIF
    ONEXP_CLEAR v2
    RETURN

set_spdcall:
    IF ra<15                                          ;set take-off calls
        keys_add()
        PRECISION 1,0,0
        PRINT
        set_spdcall2:
        WAIT 0, KEYPRESS
        PRINT_TIME 4
        IF tocall=0 OR spdcall=0
            PRINT "TAKE-OFF CALLS VR",vr
            tocall=1
            tospd=0           
        ELSE
            PRINT "TAKE-OFF CALLS OFF"
            tocall=0
        ENDIF
        spdcall=-1                ;(resets after touchdown to enter a new VR)
        WAIT 4,KEYPRESS           
        val=KEY
        WAIT 0,KEYPRESS                                   
        IF INRANGE(val,48,57)     
            PLAY "-ss1"
            spd=val-48
            PRINT "TAKE-OFF CALLS VR",spd
            PRINT_TIME 3
            WAIT 3,KEYPRESS
            PLAY "-ss1"
            val=KEY
            WAIT 0,KEYPRESS                                   
            IF INRANGE(val,48,57)     
                spd=spd*10+val-48
                PRINT "TAKE-OFF CALLS VR",spd
                WAIT 2,KEYPRESS
                PLAY "-ss1"
                val=KEY
                IF INRANGE(val,48,57)     
                    spd=spd*10+val-48
                    PRINT "TAKE-OFF CALLS VR",spd
                ENDIF
            ENDIF
            IF spd<40 OR val=SPDCALL_key
                tocall=1
                PLAY "-ss1"
                GOTO set_spdcall2
            ENDIF
            tocall=1          
            tospd=0           
            vr=spd
        ELSEIF val=SPDCALL_key
            PLAY "-ss1"
            GOTO set_spdcall2
        ENDIF
        keys_del()
    ELSE                                              ;set airspeed calls
        PLAY "-ss1"
        PRINT_TIME 3
        PRINT
        IF spdcall<1
            PRINT "AIRSPD CALLS ON"
            spd=0
            spdcall=1
            spdtime=FUNCTION timer_start()
            spdtime=spdtime-5
        ELSE
            PRINT "AIRSPD CALLS OFF"
            spdcall=0
        ENDIF
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; Autopilot heading and altitude
;-----------------------------------------------------------------------------
ap_hdg:
    keys_add()
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57)
        PLAY "-ss1"
        hdg=val-48
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57)
            hdg=hdg*10+val-48
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            IF INRANGE(val,48,57) 
                hdg=hdg*10+val-48
            ENDIF
        ENDIF
        AUTOPILOT_HEADING_HOLD=1 
        AUTOPILOT_HEADING=hdg
    ELSEIF val=APHDG_key 
        PLAY "-ss1"
        hdg=AUTOPILOT_HEADING
        AUTOPILOT_HEADING=PLANE_HEADING
        AUTOPILOT_HEADING_HOLD=1  
        WAIT 1,KEYPRESS
        val=KEY
        IF val=APHDG_key 
            PLAY "-ss1"
            AUTOPILOT_HEADING_HOLD=0
            AUTOPILOT_HEADING=hdg
            keys_del()
            RETURN
        ENDIF
    ELSE
        hdg=AUTOPILOT_HEADING
        AUTOPILOT_HEADING_HOLD=1
        AUTOPILOT_HEADING=hdg
    ENDIF                         ;(panel fix:
    hdg=AUTOPILOT_HEADING+.5      ; <- use for most panels, normal AP hdg
;    hdg=AUTOPILOT_HEADING         ; <- use for panels showing hdg 1deg less)
    IF val=APALT_key 
        GOTO ap_alt
    ENDIF
    keys_del()                 
    IF voice IREM 2
        PLAY ""              ;{delete for module}
        PLAY "fsrc04"
        dgplay(hdg)
        WAIT 2,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

ap_alt:
    keys_add()
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57)
        PLAY "-ss1"
        alt=val-48
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57) 
            alt=alt*10+val-48
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            IF INRANGE(val,48,57) 
                alt=alt*10+val-48
            ENDIF
            IF alt>655 
                alt=650
            ENDIF
        ENDIF
        AUTOPILOT_ALTITUDE_HOLD=1
        IF flch=1                      ;FL change on: resets V/S
            AUTOPILOT_ALTITUDE=PLANE_ALT
            WAIT .1
        ENDIF
;        AUTOPILOT_ALTITUDE=alt*30.48006                                 ;[m]
        AUTOPILOT_ALTITUDE=alt*100.0002                                 ;[-a]
    ELSEIF val=APALT_key 
        PLAY "-ss1"
        alt=AUTOPILOT_ALTITUDE
;        AUTOPILOT_ALTITUDE=INT(PLANE_ALT/30.48+.5)*30.48006             ;[m]
        AUTOPILOT_ALTITUDE=INT(PLANE_ALT/100+.5)*100.0002               ;[-a]
        AUTOPILOT_ALTITUDE_HOLD=1
        WAIT 1,KEYPRESS
        val=KEY
        IF val=APALT_key 
            PLAY "-ss1"
            AUTOPILOT_ALTITUDE_HOLD=0
            AUTOPILOT_ALTITUDE=alt
            keys_del()
            RETURN
        ENDIF
    ELSEIF val=FR_key
        PLAY "-ss1"
        GOTO set_flch
    ELSE
        alt=AUTOPILOT_ALTITUDE
        AUTOPILOT_ALTITUDE_HOLD=1
        IF flch=1
            AUTOPILOT_ALTITUDE=PLANE_ALT
            WAIT .1
        ENDIF
        AUTOPILOT_ALTITUDE=alt
    ENDIF
;    alt=AUTOPILOT_ALTITUDE/.3048+.5                                     ;[m]
    alt=AUTOPILOT_ALTITUDE+.5                                           ;[-a]
    IF val=APHDG_key 
        GOTO ap_hdg
    ENDIF
    keys_del()
    IF voice IREM 2
        PLAY ""              ;{delete for module}
        PLAY "fsfltlvl"
        d1play(alt IDIV 10000)
        dplay((alt/1000) IREM 10)
        dplay(alt/100 IREM 10)
        WAIT 2,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

set_flch:
    PRINT_TIME 3
    PRINT
    IF flch
       PRINT "ALT V/S MODE"            ;use V/S mode for alt select
       flch=0
    ELSE
       PRINT "ALT FL/CH MODE"          ;use FL change for alt select
       flch=1
    ENDIF
    keys_del()
    RETURN

;-----------------------------------------------------------------------------
; Autopilot heading change and altitude change
;-----------------------------------------------------------------------------
hdg_l1:
    hdg=AUTOPILOT_HEADING-1
    AUTOPILOT_HEADING=hdg
    RETURN
hdg_r1:
    hdg=AUTOPILOT_HEADING+1
    AUTOPILOT_HEADING=hdg
    RETURN
hdg_l10:
    hdg=AUTOPILOT_HEADING-10
    AUTOPILOT_HEADING=hdg
    RETURN
hdg_r10:
    hdg=AUTOPILOT_HEADING+10
    AUTOPILOT_HEADING=hdg
    RETURN

alt_dn:
;    IF AUTOPILOT_ALTITUDE<3100                                          ;[m]
;        alt=INT(AUTOPILOT_ALTITUDE/152.4-.002)*152.4003                 ;[m]
;    ELSE                                                                ;[m]
;        alt=INT(AUTOPILOT_ALTITUDE/304.8-.001)*304.8006                 ;[m]
    IF AUTOPILOT_ALTITUDE<10100                                         ;[-a]
        alt=INT(AUTOPILOT_ALTITUDE/500-.002)*500.001                    ;[-a]
    ELSE                                                                ;[-a]
        alt=INT(AUTOPILOT_ALTITUDE/1000-.001)*1000.002                  ;[-a]
    ENDIF
    AUTOPILOT_ALTITUDE=alt
    RETURN
alt_up:
;    IF AUTOPILOT_ALTITUDE<3000                                          ;[m]
;        alt=INT(AUTOPILOT_ALTITUDE/152.4+1.001)*152.4003                ;[m]
;    ELSE                                                                ;[m]
;        alt=INT(AUTOPILOT_ALTITUDE/304.8+1.0005)*304.8006               ;[m]
;        IF alt>19964.4                                                  ;[m]
;            alt=19812.03                                                ;[m]
    IF AUTOPILOT_ALTITUDE<9900                                          ;[-a]
        alt=INT(AUTOPILOT_ALTITUDE/500+1.001)*500.001                   ;[-a]
    ELSE                                                                ;[-a]
        alt=INT(AUTOPILOT_ALTITUDE/1000+1.0005)*1000.002                ;[-a]
        IF alt>65500                                                    ;[-a]
            alt=65000.1                                                 ;[-a]
        ENDIF
    ENDIF
    AUTOPILOT_ALTITUDE=alt
    RETURN

;-----------------------------------------------------------------------------
; Autoland
;-----------------------------------------------------------------------------
autoland:
    IF AUTOPILOT_APPROACH_HOLD=0 OR ra>100*cat+500 OR autoland=0 OR VOR_1_GS_AVAIL=0
        RETURN                         
    ELSEIF NOT INRANGE(VOR_1_COURSE_DEVIATION,-.5,.5) OR NOT INRANGE(VOR_1_GS_DEVIATION,-.5,.7) OR (gpwsmode>0 AND gpwsmode!=4)
        GOTO autoland_end
    ENDIF
    timer(vstime)
    IF time<20
        vscount=vscount+1                  
        vsfinal=vsfinal+VELOCITY_Y     ;determine V/S on final for autoland
        vstime=FUNCTION timer_start()
        IF ra0 AND ra<100*cat+300
            ra0=0
            vsfinal=vsfinal/vscount    ;mean V/S
            vscount=1                  ;restart V/S
            PRECISION 1,0,0
            PRINT_TIME 6
            PRINT
;            PRINT "AUTOLAND (V/S",((197*vsfinal-150)IDIV 50)*50,")"     ;[m]
            PRINT "AUTOLAND (V/S",((vsfinal-150)IDIV 50)*50,")"         ;[-a]
            PLAY "-ss1"
            WAIT .5
            PLAY "-ss1"
            WAIT .5
            PLAY "-ss1"
        ENDIF
    ELSE
        ra0=1
        vsfinal=VELOCITY_Y             ;start V/S
        vscount=1
        vstime=FUNCTION timer_start()
    ENDIF                             
    IF ra>100*cat
        RETURN                         
    ENDIF                              ;begin autoland
    vsfinal=vsfinal/vscount            ;mean V/S on final
    alt=AUTOPILOT_ALTITUDE
;    IF alt<PLANE_ALT+9                                                  ;[m]
;        alt=(MTOF(PLANE_ALT) IDIV 1000 +2)*304.8006                     ;[m]
    IF alt<PLANE_ALT+30                                                 ;[-a]
        alt=(PLANE_ALT IDIV 1000 +2)*1000.002                           ;[-a]
    ENDIF
    AUTOPILOT_ALTITUDE=0
    AUTOPILOT_APPROACH_HOLD=0
    AUTOPILOT_ALTITUDE_HOLD=1
    AUTOPILOT_LOCALIZER_HOLD=1         
    WAIT .1
    AUTOPILOT_ALTITUDE=alt
autoland2:
;    WHILE ra>65 AND VELOCITY_Y>-.07*ra                                  ;[m]
    WHILE ra>65 AND VELOCITY_Y>-14*ra                                   ;[-a] 
;        IF AUTOPILOT_ALTITUDE_HOLD=0 OR NOT INRANGE(VOR_1_COURSE_DEVIATION,-.5,.5) OR (NOT INRANGE(VOR_1_GS_DEVIATION,-.9,.9) AND ra>30*cat+90) OR NOT INRANGE(VELOCITY_Y,-.006*ra-5,0)    ;[m]
        IF AUTOPILOT_ALTITUDE_HOLD=0 OR NOT INRANGE(VOR_1_COURSE_DEVIATION,-.5,.5) OR (NOT INRANGE(VOR_1_GS_DEVIATION,-.9,.9) AND ra>30*cat+90) OR NOT INRANGE(VELOCITY_Y,-1.2*ra-1000,0)  ;[-a]
            GOTO autoland_end                    ;max.V/S at sink rate warn
        ELSEIF (ra>100 AND VOR_1_GS_DEVIATION>cat/10 AND VELOCITY_Y<.85*vsfinal) OR VELOCITY_Y<1.25*vsfinal
;            x2=PLANE_ALT-15                                             ;[m]
            x2=PLANE_ALT-50                                             ;[-a]
            IF x2>0
                AUTOPILOT_ALTITUDE=x2            ;decrease V/S
                GOTO autoland2
            ENDIF
            GOTO flare
        ENDIF
        AUTOPILOT_ALTITUDE=alt
        WAIT 1
        ra()                                     
    ENDWHILE
flare:
    ONEXP_CLEAR ap_disc  
    AUTOPILOT_HEADING=PLANE_HEADING
;    AUTOPILOT_ALTITUDE=GROUND_ALTITUDE+3.05*cat+6.1                     ;[m]
    AUTOPILOT_ALTITUDE=GROUND_ALTITUDE+10*cat+20                        ;[-a]
    AUTOPILOT_MASTER=0                           ;spd mode off
    AUTOPILOT_MASTER=1
    AUTOPILOT_ALTITUDE_HOLD=1                    ;start flare
    AUTOPILOT_HEADING_HOLD=1                     ;hold hdg during flare
    ONEXP_CHANGE AUTOPILOT_MASTER GOSUB ap_disc
    thrlimit=THROTTLE_1                          ;retard thrust levers
    ONEXP_TRUE GROUND_DISTANCE4(x1,x2,PLANE_LAT,PLANE_LON)>ias/20000 GOSUB retard
    WHILE NOT ON_GROUND
;        IF VELOCITY_Y>-1                                                ;[m]
        IF VELOCITY_Y>-200                       ;correct flare         ;[-a]
            AUTOPILOT_ALTITUDE=PLANE_ALT
        ENDIF
;        IF AUTOPILOT_ALTITUDE_HOLD=0 OR VELOCITY_Y>1                    ;[m]
        IF AUTOPILOT_ALTITUDE_HOLD=0 OR VELOCITY_Y>200                  ;[-a]
            GOTO autoland_end
        ENDIF
        ra()
    ENDWHILE
    AUTOPILOT_ALTITUDE=0
    time_ongnd(3)
    AUTOPILOT_ALTITUDE_HOLD=0
    AUTOPILOT_ALTITUDE=alt
    ONEXP_CLEAR retard
    RETURN

autoland_end:
    ONEXP_CLEAR retard
    AUTOPILOT_MASTER=0
    AUTOPILOT_ALTITUDE=alt
    IF ra>15
        PRINT_TIME 3
        PRINT
        PRINT "NO AUTOLAND"
    ENDIF
    RETURN

retard:                                ;retard thrust levers
    IF ra<cat*10+5 AND autortd AND THROTTLE_1<.8
        thr=THROTTLE_1-thrlimit/20
        IF NOT INRANGE(thr,0,thrlimit)
            ONEXP_CLEAR retard
            IF thr>thrlimit
                RETURN
            ENDIF
            thr=0
        ENDIF
        THROTTLE_1=thr
        THROTTLE_2=thr
        THROTTLE_3=thr
        THROTTLE_4=thr
    ENDIF
    x1=PLANE_LAT
    x2=PLANE_LON      
    RETURN

set_auto_rtd:                          ;via ADF key (AE) auto retard off/on
    PRINT_TIME 3
    PRINT
    IF autortd
        PRINT "AUTO RETARD OFF"
        autortd=0
        ONEXP_CLEAR retard
    ELSE
        PRINT "AUTO RETARD ON"
        autortd=1
    ENDIF
    keys_del()
    RETURN

set_autoland:                          ;via ADF key (AL) autoland off/on
    PRINT_TIME 3
    PRINT
    IF autoland
        PRINT "AUTOLAND OFF"
        autoland=0
    ELSE
        PRINT "AUTOLAND ON"
        autoland=1
    ENDIF
    keys_del()
    RETURN

set_cat:                               ;via ADF key (AC)
    PRECISION 1,0,0                    ;set aircraft category for autoland
    PRINT_TIME 2
    PRINT
    ON cat-1 GOSUB catA,catB,catC,catD,catE
    PRINT "  (A-E)"
    WAIT 4,KEYPRESS
    val=KEY
    IF val=keyA
        cat=1
    ELSEIF val=keyB
        cat=2
    ELSEIF val=keyC
        cat=3
    ELSEIF val=keyD
        cat=4
    ELSEIF val=keyE
        cat=5
    ELSE
        GOTO err
    ENDIF
    PLAY "-ss1"
    ON cat-1 GOSUB catA,catB,catC,catD,catE
    PRINT_TIME 0
    PRINT
    PRINT_TIME 3                       
    IF gear=INT(gear)                  ;if aircraft hasn't touched ground
        gear=cat*2                     ;  set gear height by a/c category
    ENDIF
    keys_del()
    RETURN
catA:
    PRINT "AIRCRAFT CAT-A",
    RETURN
catB:
    PRINT "AIRCRAFT CAT-B",
    RETURN
catC:
    PRINT "AIRCRAFT CAT-C",
    RETURN
catD:
    PRINT "AIRCRAFT CAT-D",
    RETURN
catE:
    PRINT "AIRCRAFT CAT-E",
    RETURN

;-----------------------------------------------------------------------------
; Auto reverse
;-----------------------------------------------------------------------------
DEFINE PROCEDURE auto_reverse(rev)     ;select reverse thrust
    WHILE INRANGE(THROTTLE_1,-rev,.1) AND ias>80 AND VELOCITY_INDICATED>63 AND autorev
        thr=THROTTLE_1-.04
        THROTTLE_1=thr
        THROTTLE_2=thr
        THROTTLE_3=thr
        THROTTLE_4=thr
        WAIT .1
    ENDWHILE
    reverse=2
ENDDEFINE

DEFINE PROCEDURE auto_reverse2()       ;gradually reduce reverse thrust
    thr=-1
    WHILE THROTTLE_1<0 AND THROTTLE_1>thr-.1 AND autorev
        thr=THROTTLE_1+.01
        IF thr<(33-VELOCITY_INDICATED)/30        ;idle reverse at 30kts
            thr=thr+.04
        ENDIF
        IF thr>0
            thr=0
        ENDIF
        THROTTLE_1=thr
        THROTTLE_2=thr
        THROTTLE_3=thr
        THROTTLE_4=thr
        WAIT .1
    ENDWHILE
    reverse=0
ENDDEFINE

auto_restow:                           ;incomplete stowage: restow reversers
    thr=THROTTLE_1
    THROTTLE_1=thr
    THROTTLE_2=thr
    THROTTLE_3=thr
    THROTTLE_4=thr
    ONEXP_CLEAR auto_restow
    RETURN

set_auto_rev:                          ;via ADF key (AR) auto reverse off/on
    PRINT_TIME 3
    PRINT
    IF autorev
        PRINT "AUTO REVERSE OFF"
        autorev=0
    ELSE
        PRINT "AUTO REVERSE ON"
        autorev=1
    ENDIF
    keys_del()
    RETURN

DEFINE PROCEDURE time_ongnd(gnd_time)  ;wait until gnd_time seconds on ground
    time=0
    x1=FUNCTION timer_start()
    WHILE time<gnd_time AND ra<15
        IF NOT ON_GROUND
            x1=FUNCTION timer_start()
        ENDIF
        ra()
        timer(x1)
    ENDWHILE
    on_gnd()
ENDDEFINE

pitch_ongnd:                           ;wait until nose gear on ground
    x1=PLANE_PITCH
    WAIT 1
    IF PLANE_PITCH<x1 AND BRAKE_LEFT_POSITION=0
        GOTO pitch_ongnd
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; Radios
;-----------------------------------------------------------------------------
adf:
    keys_add()
    adf_input:
    freq=0
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF val=49 
        PLAY "-ss1"
        freq=1000
        WAIT 2,KEYPRESS
        val=KEY
        WAIT 0,KEYPRESS
    ENDIF
    IF INRANGE(val,48,57) 
        PLAY "-ss1"
        freq=freq+(val-48)*100
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57) 
            freq=freq+(val-48)*10
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            WAIT 0,KEYPRESS
            IF INRANGE(val,48,57) 
                freq=freq+val-48
                WAIT 2,KEYPRESS
                PLAY "-ss1"
                val=KEY
                IF INRANGE(val,48,57) 
                    freq=freq+(val-48)/10
                ENDIF
            ENDIF
        ENDIF
        IF NOT INRANGE(freq,200,1699.9) 
            GOTO err
        ENDIF
        ADF_FREQ=freq+.01
    ELSEIF val=ADF_key 
        PLAY "-ss1"
        IF swap!=1
            freq=ADF_FREQ
            ADF_FREQ=adf
            adf=freq
            swap=1
        ELSE
            swap=2
        ENDIF
        GOTO adf_input
    ELSEIF (val=TO_key OR val=FR_key) AND ADF_ACTIVE  ;crs to/from
        PLAY "-ss1"                                   ;    qdm/qdr
        IF val=TO_key
            crs=INT(ADF_BEARING+.5)
        ELSE
            crs=INT(ADF_BEARING+180.5)
        ENDIF
        crs=FUNCTION crs_chk()
        keys_del()
        GOTO crs_play2
    ELSEIF val=DIST_key AND ADF_ACTIVE                ;dist
        PLAY "-ss1"
        freq=GROUND_DISTANCE(ADF_LAT,ADF_LON)
        GOTO dist_play
    ELSEIF val=CAT_key                                ;AC aircraft category
        PLAY "-ss1"
        GOTO set_cat
    ELSEIF val=LAND_key                               ;AL autoland on/off
        PLAY "-ss1"
        GOTO set_autoland
    ELSEIF val=REV_key                                ;AR auto reverse on/off
        PLAY "-ss1"
        GOTO set_auto_rev
    ELSEIF val=RTD_key                                ;AE auto retard on/off
        PLAY "-ss1"
        GOTO set_auto_rtd
    ELSEIF swap=0
        GOTO err
    ENDIF
    freq=ADF_FREQ+.01
    keys_del()
    IF voice>1
        PLAY ""              ;{delete for module}
        d1play(freq IDIV 1000)
        dplay((freq/100) IREM 10)
        dplay((freq/10) IREM 10)
        dplay(freq IREM 10)
        freq=(freq*10) IREM 10
        IF freq!=0
            PLAY "fs_pnt"
            dplay(freq)
        ENDIF
        WAIT 2,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

com:
    keys_add()
    com_input:
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57) 
        GOSUB freq
        IF NOT INRANGE(freq,118,136.99)
            GOTO err
        ENDIF
        COM_FREQ=INT((freq+.006)*40)/40
        WAIT .1
        PLAY ""
    ELSEIF val=COM_key
        PLAY ""
        PLAY "-ss1"
        IF swap!=1
            freq=COM_FREQ
            COM_FREQ=com
            com=freq
            swap=1
        ELSE
            swap=2
        ENDIF
        GOTO com_input
;    ELSEIF val=FR_key                  ;{add for PF98 / WPP4 module}
;        PLAY ""                        ;{add for PF98 / WPP4 module}
;        PLAY "-ss1"                    ;{add for PF98 / WPP4 module}
;        COM_FREQ=iFreq                 ;{add for ProFlight98 module}
;        COM_FREQ=freqToSay/100         ;{add for WinPlanner4 module}
;        keys_del()                     ;{add for PF98 / WPP4 module}
;        GOTO Cmd0x                     ;{add for ProFlight98 module}
;        GOTO wantCheckIn               ;{add for WinPlanner4 module}
;    ELSEIF val=TO_key                  ;{add for ProFlight98 module}
;        PLAY ""                        ;{add for ProFlight98 module}
;        PLAY "-ss1"                    ;{add for ProFlight98 module}
;        COM_FREQ=iTowerOrigFreq        ;{add for ProFlight98 module}
;        keys_del()                     ;{add for ProFlight98 module}
;        GOTO Cmd6x                     ;{add for ProFlight98 module}
;    ELSEIF val=LAND_key                ;{add for ProFlight98 module}
;        PLAY ""                        ;{add for ProFlight98 module}
;        PLAY "-ss1"                    ;{add for ProFlight98 module}
;        COM_FREQ=iFreq                 ;{add for ProFlight98 module}
;        keys_del()                     ;{add for ProFlight98 module}
;        GOTO Cmd1x                     ;{add for ProFlight98 module}
;    ELSEIF val=COM2_key                ;{add for module}  ;CD COM2 (ATC)  
;        PLAY "-ss1"                    ;{add for module}
;        swap=0                         ;{add for module}
;        GOTO com2                      ;{add for module}
    ELSEIF val=RATE_key                               ;CR COM rate (ATC)
        PLAY "-ss1"                     
        GOTO set_com_rate                
    ELSEIF val=keyA                                   ;CA call attendant
        belts0=belts
        GOTO call_attend                
    ELSEIF val=keyB                                   ;CB fasten belts
        belts0=belts
        GOTO fasten_belts                
;    ELSEIF val=XPDR_key                               ;CT xpdr (backup)
;        GOTO xpdr                                     
    ELSEIF swap=0
        GOTO err
    ENDIF
    freq=COM_FREQ-99.999
    GOTO freq_play

com2:
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57) 
        GOSUB freq
        IF NOT INRANGE(freq,118,136.99)
            GOTO err
        ENDIF
        com2freq=INT((freq+.006)*40)/40   
    ELSEIF val=COM2_key                 
        PLAY "-ss1"         
        IF swap!=1             
            freq=com2freq     
            com2freq=com2  
            com2=freq  
            swap=1         
        ELSE                 
            swap=2                     
        ENDIF                          
        GOTO com2                
    ELSEIF val=RATE_key                               ;CDR COM2 rate (ATC)
        PLAY "-ss1"                     
        GOTO set_com2_rate                
    ELSEIF swap=0
        GOTO err
    ENDIF
    freq=com2freq-99.999 
    GOSUB freq_play     
    GOTO com2_change   

DEFINE FUNCTION crs_chk()
    IF crs>360 
        crs=crs-360
    ELSEIF crs<1 
        crs=crs+360
    ENDIF
    RETURN crs
ENDDEFINE

crs_play:
    keys_del()
    IF voice>1
        crs_play2:
        PLAY ""              ;{delete for module}
        PLAY "fsrc05"
        dgplay(crs)
        WAIT 2,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

dist_play:
    keys_del()
    PLAY ""                  ;{delete for module}
    IF freq<100
        d1play(freq IDIV 10)
        dplay(freq IREM 10)
        PLAY "fs_pnt"
        dplay((freq*10) IREM 10)
    ELSEIF freq<1000
        dplay(freq IDIV 100)
        dplay((freq/10) IREM 10)
        dplay(freq IREM 10)
    ENDIF
    WAIT 2,KEYPRESS
    GOTO gpws_input

err:
    PLAY "-ss2"
    keys_del()
    RETURN

freq:
    PLAY "-ss1"
    freq=(val-48)*100
    WAIT 2,KEYPRESS
    PLAY "-ss1"
    val=KEY
    WAIT 0,KEYPRESS
    IF INRANGE(val,48,57) 
        freq=freq+(val-48)*10
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57) 
            freq=freq+val-48
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            WAIT 0,KEYPRESS
            IF INRANGE(val,48,57) 
                freq=freq+(val-48)/10
                WAIT 2,KEYPRESS
                PLAY "-ss1"
                val=KEY
                IF INRANGE(val,48,57) 
                    freq=freq+(val-48)/100
                ENDIF
            ENDIF
        ENDIF
    ENDIF
    RETURN

freq_play:
    keys_del()
    IF voice>1
        PLAY ""              ;{delete for module}
        PLAY "fs_1"
        dplay(freq IDIV 10)
        dplay(freq IREM 10)
        PLAY "fs_pnt"
        dplay((freq*10) IREM 10)
        d1play((freq*100) IREM 10)
        WAIT 2.5,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

nav1:
    keys_add()
    nav1_input:
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57)                             ;freq
        GOSUB freq
        IF NOT INRANGE(freq,108,117.99)
            GOTO err
        ENDIF
        NAV1_FREQ=INT(freq*20)/20
    ELSEIF val=NAV1_key 
        PLAY "-ss1"
        IF swap!=1
            freq=NAV1_FREQ
            NAV1_FREQ=nav1
            nav1=freq
            swap=1
        ELSE
            swap=2
        ENDIF
        GOTO nav1_input
    ELSEIF val=CRS_key                                ;crs
        GOSUB nav_crs
        IF NOT INRANGE(crs,0,360) 
            GOTO err
        ENDIF
        VOR_1_OBS=crs
        GOTO crs_play
    ELSEIF (val=TO_key OR val=FR_key) AND VOR_1_ACTIVE     ;crs to/from
        PLAY "-ss1"
        IF VOR_1_LOCALIZER_AVAIL
            IF voice>1
                WAIT .1      ;{delete for module}
                PLAY ""      ;{delete for module}
                IF VOR_1_GS_AVAIL
                    PLAY "fsapp_i"
                ELSE
                    PLAY "fsapp_l"
                ENDIF
                WAIT .8
            ENDIF
            crs=INT(VOR_1_LOCALIZER-MAGVAR+.5)
        ELSEIF val=TO_key 
            crs=INT(VOR_1_RADIAL+180.5)
        ELSE
            crs=INT(VOR_1_RADIAL+.5)
        ENDIF
        VOR_1_OBS=FUNCTION crs_chk()
        GOTO crs_play
    ELSEIF val=DIST_key AND VOR_1_ACTIVE              ;dist
        PLAY "-ss1"
        freq=GROUND_DISTANCE(VOR_1_LAT,VOR_1_LON)
        GOTO dist_play
    ELSEIF val=NAV2_key
        PLAY "-ss1"
        IF swap!=1                     ;Delete these 3 lines if you want NAV2 
            GOTO nav_swap              ;via NAV1 key only (NM), also delete 
        ENDIF                          ;line: ONKEY NAV2_key (see Adding keys)
        swap=0                                        
        GOTO nav2_input
    ELSEIF swap=0
        GOTO err
    ENDIF
    freq=NAV1_FREQ-99.999
    GOTO freq_play

nav2:
    keys_add()
    nav2_input:
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,57)                             ;freq
        GOSUB freq
        IF NOT INRANGE(freq,108,117.99) 
            GOTO err
        ENDIF
        NAV2_FREQ=INT(freq*20)/20
    ELSEIF val=NAV2_key 
        PLAY "-ss1"
        IF swap!=1
            freq=NAV2_FREQ
            NAV2_FREQ=nav2
            nav2=freq
            swap=1
        ELSE
            swap=2
        ENDIF
        GOTO nav2_input
    ELSEIF val=CRS_key                                ;crs
        GOSUB nav_crs
        IF NOT INRANGE(crs,0,360) 
            GOTO err
        ENDIF
        VOR_2_OBS=crs
        GOTO crs_play
    ELSEIF (val=TO_key OR val=FR_key) AND VOR_2_ACTIVE     ;crs to/from
        PLAY "-ss1"
        IF val=TO_key 
            crs=INT(VOR_2_RADIAL+180.5)
        ELSE
            crs=INT(VOR_2_RADIAL+.5)
        ENDIF
        VOR_2_OBS=FUNCTION crs_chk()
        GOTO crs_play
    ELSEIF val=DIST_key AND VOR_2_ACTIVE              ;dist
        PLAY "-ss1"
        freq=GROUND_DISTANCE(VOR_2_LAT,VOR_2_LON)
        GOTO dist_play
    ELSEIF val=NAV1_key
        PLAY "-ss1"
        IF swap!=1
            GOTO nav_swap
        ENDIF
        swap=0
        GOTO nav1_input
    ELSEIF swap=0
        GOTO err
    ENDIF
    freq=NAV2_FREQ-99.999
    GOTO freq_play

nav_crs:
    PLAY "-ss1"
    crs=-1
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS
    IF INRANGE(val,48,57) 
        PLAY "-ss1"
        crs=val-48
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,57) 
            crs=crs*10+val-48
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            IF INRANGE(val,48,57) 
                crs=crs*10+val-48
            ENDIF
        ENDIF
    ENDIF
    RETURN

nav_swap:
    freq=NAV1_FREQ
    NAV1_FREQ=NAV2_FREQ
    NAV2_FREQ=freq
    crs=VOR_1_OBS
    VOR_1_OBS=VOR_2_OBS
    VOR_2_OBS=crs
    keys_del()
    RETURN

set_com_rate:
    PRECISION 1,0,0
    PRINT_TIME 4
    PRINT
;    PRINT "COM1 RATE ",com1rate,"  (0-9)"   ;{add for module}
    PRINT "COM RATE ",com2rate,"  (0-9)"    ;{delete for module}
    PRINT_TIME 2
    WAIT 4,KEYPRESS
    val=KEY
    IF INRANGE(val,48,57)     
        PLAY "-ss1"
;        com1rate=val-48                     ;{add for module}
;        PRINT "COM1 RATE ",com1rate         ;{add for module}
        com2rate=val-48                     ;{delete for module}
        PRINT "COM RATE ",com2rate          ;{delete for module}
    ELSE
        PLAY "-ss2"
    ENDIF
    keys_del()
    RETURN                    

set_com2_rate:
    PRECISION 1,0,0
    PRINT_TIME 4
    PRINT
    PRINT "COM2 RATE ",com2rate,"  (0-9)"
    PRINT_TIME 2
    WAIT 4,KEYPRESS
    val=KEY
    IF INRANGE(val,48,57)     
        PLAY "-ss1"
        com2rate=val-48
        PRINT "COM2 RATE ",com2rate
    ELSE
        PLAY "-ss2"
    ENDIF
    keys_del()
    RETURN                    

xpdr:
    keys_add()
    freq=TRANS_FREQ
    WAIT 2,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS                                   
    IF INRANGE(val,48,55) 
        PLAY "-ss1"
        freq=(val-48)*1000
        WAIT 2,KEYPRESS
        PLAY "-ss1"
        val=KEY
        WAIT 0,KEYPRESS
        IF INRANGE(val,48,55) 
            freq=freq+(val-48)*100
            WAIT 2,KEYPRESS
            PLAY "-ss1"
            val=KEY
            WAIT 0,KEYPRESS
            IF INRANGE(val,48,55) 
                freq=freq+(val-48)*10
                WAIT 2,KEYPRESS
                PLAY "-ss1"
                val=KEY
                IF INRANGE(val,48,55) 
                    freq=freq+val-48
                ENDIF
            ENDIF
        ENDIF
    ELSEIF val=XPDR_key                               ;TT 
        PLAY "-ss1"                                   
        IF ON_GROUND
            GOTO to_config                            ;take-off config test
        ENDIF
        GOTO ra_play                                  ;radio altitude
    ELSEIF val=RATE_key                               ;TR set/test apl rate
        PLAY "-ss1"
        GOTO set_aplrate_min
;    ELSEIF val=FR_key        ;{add for PF98 / WPP4 module}  ;TF set xpdr
;        PLAY "-ss1"          ;{add for PF98 / WPP4 module}
;        freq=iXPNDR          ;{add for ProFlight98 module}
;        freq=squawk          ;{add for WinPlanner4 module}
    ELSE
        GOTO err
    ENDIF
    TRANS_FREQ=freq
    keys_del()
    IF voice>1
        PLAY ""              ;{delete for module}
        dplay(freq IDIV 1000)
        dplay((freq/100) IREM 10)
        dplay((freq/10) IREM 10)
        dplay(freq IREM 10)
        WAIT 2,KEYPRESS
        GOTO gpws_input
    ENDIF
    RETURN

;-----------------------------------------------------------------------------
; ATC and ATIS
;-----------------------------------------------------------------------------
com_change:                            
    PLAY ""
;    RETURN                   ;{add for module}
com2_change:
    atcgroup=0               
    com2freq=COM_FREQ        ;{delete for module}
;/////////////////////////////////////////////////////////////////////////////
    IF com2freq=121.975                ;(you can add your own ATC freqs here,
        atcgroup=29                    ; also add ,a29,a30,a31 etc. to the 
    ELSEIF com2freq=119.05             ; atc_play procedure below, and add
        atcgroup=30                    ; procedures a29: a30: a31: etc. which
;    ELSEIF com2freq=121.5              ; contain the freq(=folder name), see
;        atcgroup=31                    ; examples a29: a30: some pages down).
;    ELSEIF com2freq=126.9            
;        atcgroup=32

;/////////////////////////////////////////////////////////////////////////////
    ELSEIF (com2freq*1000+.1) IREM 100 >0        ;second or third decimal >0
        RETURN
    ENDIF
    IF atcgroup=0
        atcgroup=com2freq*10 IREM 10             ;first decimal
        IF INRANGE(com2freq,118.0,118.9)
            atcgroup=atcgroup+1                  ;atc group 1-10
        ELSEIF INRANGE(com2freq,119.1,119.9)
            atcgroup=atcgroup+10                 ;atc group 11-19
        ELSEIF INRANGE(com2freq,121.7,121.9)
            atcgroup=atcgroup+13                 ;atc group 20-22
        ELSEIF INRANGE(com2freq,123.7,128.7) AND atcgroup=7
            atcgroup=INT(com2freq)-100           ;atc group 23-28
        ELSEIF com2freq=122.0
            atcgroup=-1                          ;atis (no atc group)
            atis=0
            atistime=FUNCTION timer_start()
        ELSE
            atcgroup=0               
        ENDIF
    ENDIF
    IF atcgroup>0 AND com2rate>0
        GOTO msg_play
    ENDIF                              
    RETURN

atc_play:
    IF atcgroup<0
        timer(atistime)
        IF time>0
            GOSUB atis_play
        ENDIF
        trim=ELEVATOR_TRIM_POSITION
    ELSEIF atcgroup>0
        timer(msgtime)
        IF time>playtime AND com2rate>0
            msg_play:
            atcmsg=INT(RANDOM*30+1)              ;pick a random message 1-30
            IF atcmsg=lastmsg                    ;avoid double atc messages
                GOTO msg_play                    
            ENDIF                                
;/////////////////////////////////////////////////////////////////////////////
            ;(add ,a31,a32 etc. to the next line for each freq you've added)
            ON atcgroup-1 GOSUB a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30
;/////////////////////////////////////////////////////////////////////////////
            lastmsg=atcmsg
            msgtime=FUNCTION timer_start()
            playtime=msgpause+1200*RANDOM/(com2rate*com2rate)
            trim=ELEVATOR_TRIM_POSITION
        ENDIF
    ENDIF
    RETURN

atis_play:
    IF atis=0 OR time>9
        atis=1
        PLAY "fsfss135"                ;"latest weather report has winds"
        IF WIND_SURF_VEL<3     
            PLAY "fsfss153"            ;"calm"
            WAIT 2
        ELSE
            x1=WIND_SURF_DIR+MAGVAR+5
            IF x1>=370
                x1=x1-360
            ELSEIF x1<10     
                x1=x1+360
            ENDIF                      
            dplay(x1 IDIV 100)     
            dplay((x1/10) IREM 10)     ;wind direction
            PLAY "fs_0"
            PLAY "fsat"                ;"at"
            x1=WIND_SURF_VEL
            d1play(x1 IDIV 10)         ;wind speed
            dplay(x1 IREM 10)
            WAIT 4
        ENDIF
    ELSEIF atis=1 AND CLOUD_LOW_COVERAGE+CLOUD_HIGH_COVERAGE+CLOUD_THUNDER_COVERAGE=0
        atis=4
        PLAY "fsfss150"                                    ;"clear skies"
        WAIT 1
    ELSEIF atis=1 AND CLOUD_LOW_COVERAGE>0 AND CLOUD_LOW_BASE>0    
        atis=2                                              
        atis_clouds(CLOUD_LOW_COVERAGE, CLOUD_LOW_BASE)    ;low cloud layer       
        WAIT 2
    ELSEIF atis<3 AND CLOUD_HIGH_COVERAGE>0 AND CLOUD_HIGH_BASE>0 AND NOT INRANGE(CLOUD_HIGH_BASE-CLOUD_LOW_BASE,-99,99)
        atis=3                                               
        atis_clouds(CLOUD_HIGH_COVERAGE, CLOUD_HIGH_BASE)  ;high cloud layer 
        WAIT 2
    ELSEIF atis<4 AND CLOUD_THUNDER_COVERAGE>0 AND CLOUD_THUNDER_BASE>0    
        atis=4                                               
        atis_clouds(CLOUD_THUNDER_COVERAGE, CLOUD_THUNDER_BASE) ;thunderstorm           
        PLAY "fs_c"                                             ;cumulonimbus    
        PLAY "fs_b"
        WAIT 3
    ELSEIF atis<5     
        atis=5
        PLAY "fs_q"                                   ;QNH altimiter setting
        PLAY "fs_n"
        PLAY "fs_h"                                   
        atis_qnh(INHGTOMB(BAROMETRIC_PRESSURE)+.5, 0) ;QNH in mb
        WAIT 3
    ELSEIF atis<6
        atis=6
        atis_qnh(BAROMETRIC_PRESSURE*100, 1)          ;QNH in inches
        WAIT 2
    ELSEIF atis<8
        atis=atis+1
    ELSE
        atis=0
    ENDIF
    atistime=FUNCTION timer_start()
    RETURN       

DEFINE PROCEDURE atis_clouds(cover, base)
    IF cover<=.5
        PLAY "fsfss146"            ;(few and) "scattered clouds"
    ELSEIF cover<1     
        PLAY "fsfss147"            ;"broken clouds"
    ELSE
        PLAY "fsfss148"            ;"overcast"
    ENDIF
    IF base<2500                   ;altitude MSL of base of cloud layer
        base=base+40
        x1=base IDIV 1000
        IF x1!=0     
            dplay(x1)
            PLAY "fsthous"
        ENDIF
        x1=(base/100) IREM 10
        IF x1!=0     
            dplay(x1)
            PLAY "fshund"
        ENDIF
    ELSEIF base<9800     
        base=base+200
        d1play(base IDIV 1000)
        PLAY "fsthous"
        IF (base/100) IREM 10 >=5     
            PLAY "fs_5"
            PLAY "fshund"
        ENDIF
    ELSE    
        base=base+400
        d1play(base IDIV 10000)
        dplay((base/1000) IREM 10)
        PLAY "fsthous"
    ENDIF
ENDDEFINE

DEFINE PROCEDURE atis_qnh(qnh, point)
    d1play(qnh IDIV 1000)
    dplay((qnh/100) IREM 10)
    IF point     
        PLAY "fs_pnt"              ;"point"
    ENDIF
    dplay((qnh/10) IREM 10)
    dplay(qnh IREM 10)
ENDDEFINE

a1:
    PLAY_GROUP "fsatc_$", atcmsg, 31
;    msgpause=6          ;option: msgpause can be adjusted for each ATC freq
    RETURN              ; set value to longest wav in each folder (seconds)
a2:
    PLAY_GROUP "\118.1\fsatc_$", atcmsg, 31
;    msgpause=20        ;etc...
    RETURN
a3:
    PLAY_GROUP "\118.2\fsatc_$", atcmsg, 31
    RETURN
a4:
    PLAY_GROUP "\118.3\fsatc_$", atcmsg, 31
    RETURN
a5:
    PLAY_GROUP "\118.4\fsatc_$", atcmsg, 31
    RETURN
a6:
    PLAY_GROUP "\118.5\fsatc_$", atcmsg, 31
    RETURN
a7:
    PLAY_GROUP "\118.6\fsatc_$", atcmsg, 31
    RETURN
a8:
    PLAY_GROUP "\118.7\fsatc_$", atcmsg, 31
    RETURN
a9:
    PLAY_GROUP "\118.8\fsatc_$", atcmsg, 31
    RETURN
a10:
    PLAY_GROUP "\118.9\fsatc_$", atcmsg, 31
    RETURN
a11:
    PLAY_GROUP "\119.1\fsatc_$", atcmsg, 31
    RETURN
a12:
    PLAY_GROUP "\119.2\fsatc_$", atcmsg, 31
    RETURN
a13:
    PLAY_GROUP "\119.3\fsatc_$", atcmsg, 31
    RETURN
a14:
    PLAY_GROUP "\119.4\fsatc_$", atcmsg, 31
    RETURN
a15:
    PLAY_GROUP "\119.5\fsatc_$", atcmsg, 31
    RETURN
a16:
    PLAY_GROUP "\119.6\fsatc_$", atcmsg, 31
    RETURN
a17:
    PLAY_GROUP "\119.7\fsatc_$", atcmsg, 31
    RETURN
a18:
    PLAY_GROUP "\119.8\fsatc_$", atcmsg, 31
    RETURN
a19:
    PLAY_GROUP "\119.9\fsatc_$", atcmsg, 31
    RETURN
a20:
    PLAY_GROUP "\121.7\fsatc_$", atcmsg, 31
    RETURN
a21:
    PLAY_GROUP "\121.8\fsatc_$", atcmsg, 31
    RETURN
a22:
    PLAY_GROUP "\121.9\fsatc_$", atcmsg, 31
    RETURN
a23:
    PLAY_GROUP "\123.7\fsatc_$", atcmsg, 31
    RETURN
a24:
    PLAY_GROUP "\124.7\fsatc_$", atcmsg, 31
    RETURN
a25:
    PLAY_GROUP "\125.7\fsatc_$", atcmsg, 31
    RETURN
a26:
    PLAY_GROUP "\126.7\fsatc_$", atcmsg, 31
    RETURN
a27:
    PLAY_GROUP "\127.7\fsatc_$", atcmsg, 31
    RETURN
a28:
    PLAY_GROUP "\128.7\fsatc_$", atcmsg, 31
    RETURN
;/////////////////////////////////////////////////////////////////////////////
a29:
    PLAY_GROUP "\121.975\fsatc_$", atcmsg, 31
    RETURN
a30:
    PLAY_GROUP "\119.05\fsatc_$", atcmsg, 31
    RETURN
;/////////////////////////////////////////////////////////////////////////////

;-----------------------------------------------------------------------------
; Fasten Belts and Flightcrew Briefings
;-----------------------------------------------------------------------------
call_attend:
    PRINT_TIME 3
    PRINT
    attend2:
    IF swap=0
        PRINT "ATTEND CALL"
        PLAY ""
        PLAY "-attend"
        swap=1
    ELSEIF attend
        PRINT "ATTEND OFF"
        attend=0
    ELSE
        PRINT "ATTEND ON"
        PLAY "-attend"
        attend=1
    ENDIF
    chtime=60*MINUTE+SECOND
    attend3:
    WAIT 3,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS
    IF val=keyA
        GOTO attend2
    ELSEIF val=RATE_key OR INRANGE(val,48,57)    ;R=repeat/0=reset/1-9=play
        PLAY "-ss1"
        IF INRANGE(val,48,57)
            brfg=val-48
        ENDIF
        GOSUB br_play
        swap=-1
        IF val=48
            swap=-2
        ENDIF
    ELSEIF val=keyB
        swap=0
        GOTO fasten_belts
    ELSEIF val=COM_key
        PLAY "-ss1"
        swap=0
        GOTO attend3
    ENDIF
    GOTO briefing

fasten_belts:
    x2=(belts>1)                                 
    IF belts=1 OR (belts=3 AND (FLAPS_LEFT_POSITION>0 OR GEAR_2_POSITION>0))
        swap=1                                   ;first switch ON <-> OFF
    ENDIF                                        ;         and ON -> OFF(AUTO) 
    belts2:
    IF swap
        IF belts=3                               ;ON
            belts=0                              
        ELSEIF belts=0                           ;OFF
            belts=1+(FLAPS_LEFT_POSITION>0 OR GEAR_2_POSITION>0)
        ELSE                                     ;AUTO 
            belts=3
        ENDIF
    ELSEIF belts=0                               ;OFF
        belts=3
    ELSEIF belts=3                               ;ON
        belts=1+(FLAPS_LEFT_POSITION>0 OR GEAR_2_POSITION>0)
    ELSE                                         ;AUTO
        belts=0
    ENDIF
    GOSUB belts_play
    belts3:
    WAIT 3,KEYPRESS
    val=KEY
    WAIT 0,KEYPRESS
    IF val=keyB
        GOTO belts2
    ELSEIF val=keyA
        swap=0
        GOTO call_attend
    ELSEIF val=COM_key
        PLAY "-ss1"
        GOTO belts3
    ENDIF
    GOTO briefing
    
belts_auto:
    ONEXP_CLEAR belts_on
    ONEXP_CLEAR belts_off
    IF belts=1
        ONEXP_TRUE FLAPS_LEFT_POSITION>0 OR GEAR_2_POSITION>0 GOSUB belts_on
    ELSEIF belts=2
        ONEXP_TRUE FLAPS_LEFT_POSITION=0 AND GEAR_2_POSITION=0 GOSUB belts_off
    ENDIF
    keys_del()
    RETURN

belts_off:
    belts=1
    x2=-1
    GOSUB belts_play
    GOTO briefing

belts_on:
    belts=2
    x2=-1
    GOSUB belts_play
    GOTO briefing

belts_play:
    PRINT_TIME 3
    PRINT
    IF belts=3
        PRINT "FASTEN BELTS ON"
    ELSEIF belts=2
        PRINT "FASTEN BELTS ON (AUTO)"
    ELSEIF belts=1
        PRINT "FASTEN BELTS OFF (AUTO)"
    ELSE
        PRINT "FASTEN BELTS OFF"
    ENDIF
    IF x2!=(belts>1)                             ;play belt change only
        PLAY "-chime"
        x2=(belts>1)
        chtime=60*MINUTE+SECOND
    ENDIF
    RETURN

br_play:
    GOSUB ch_play
    ON brfg-1 GOSUB br1,br2,br3,br4,br5,br6,br7,br8,br9
    RETURN

ch_play:
    IF 60*MINUTE+SECOND>chtime+7
        PLAY "-chime"
    ENDIF
    RETURN

DEFINE PROCEDURE br_time(sec,sec_ran)
    time0=60*MINUTE+SECOND
    brtime=time0+INT(sec+sec_ran*RANDOM)
ENDDEFINE

briefing:
    IF attend=0 OR (belts=0 AND ON_GROUND) OR swap<-1
        ONEXP_CLEAR dep_beforepush
        ONEXP_CLEAR dep_beforetaxi
        ONEXP_CLEAR dep_taxi
        ONEXP_CLEAR dep_beforeto
        ONEXP_CLEAR des_chk
        ONEXP_CLEAR alt_chk
        ONEXP_CLEAR arr_touchdown
        ONEXP_CLEAR arr_taxichk
        ONEXP_CLEAR arr_taxi
        ONEXP_CLEAR arr_taxi2
        brfg=0
        crzalt=-1
    ELSEIF swap>-1
        IF crzalt<PLANE_ALT
            crzalt=PLANE_ALT
        ENDIF
        IF belts>1                               ;belts on
            IF ON_GROUND
                IF brfg=0                             
                    GOSUB dep_onboard            ;gate departure
                ELSE
                    br_time(0,0)
                ENDIF
;            ELSEIF PLANE_ALT/crzalt<.9 OR VELOCITY_Y<-1                 ;[m]
            ELSEIF PLANE_ALT/crzalt<.9 OR VELOCITY_Y<-200               ;[-a]
                ONEXP_TRUE NOT INRANGE(PLANE_ALT/crzalt,.9,1.1) OR belts<2 GOSUB des_chk
;            ELSEIF belts>2 AND belts0<2 AND (brfg=5 OR VELOCITY_Y<1)    ;[m]
            ELSEIF belts>2 AND belts0<2 AND (brfg=5 OR VELOCITY_Y<200)  ;[-a]
                GOSUB ch_play 
                GOSUB br6                        ;belts off -> on
            ENDIF
        ELSEIF NOT ON_GROUND                     ;belts off (after take-off)
            ONEXP_TRUE NOT INRANGE(PLANE_ALT/crzalt,.7,1.1) GOSUB alt_chk
        ENDIF        
    ENDIF
    GOTO belts_auto
    
dep_onboard:
    x1=PLANE_LAT
    x2=PLANE_LON
    WAIT 1
    IF GROUND_DISTANCE4(x1,x2,PLANE_LAT,PLANE_LON)>.001 OR THROTTLE_1>.1 OR FLAPS_LEFT_POSITION>0
        brfg=-1                                  ;moving or flaps set -> taxi
        ONEXP_TRUE FLAPS_LEFT_POSITION>0 OR NOT ON_GROUND GOSUB dep_taxi
        RETURN
    ELSE
        brfg=1                                   ;on board
        GOSUB br_play                                
        br_time(50,20)
        ONEXP_TRUE NOT INRANGE(60*MINUTE+SECOND,time0,brtime) OR THROTTLE_1>.1 GOSUB dep_beforepush
    ENDIF
    RETURN

dep_beforepush:
    ONEXP_CLEAR dep_beforepush
    IF THROTTLE_1<.1 AND brfg<2
        brfg=2                                   ;before push
        GOSUB br_play                                
    ENDIF
    br_time(90,30)
    pbrk=PARKING_BRAKES
    ONEXP_TRUE NOT INRANGE(60*MINUTE+SECOND,time0,brtime) OR pbrk!=PARKING_BRAKES GOSUB dep_beforetaxi
    RETURN

dep_beforetaxi:
    IF THROTTLE_1<.85 AND ON_GROUND AND brfg<3
        IF THROTTLE_1>.5 OR pbrk!=PARKING_BRAKES
            br_time(5,0)
            pbrk=PARKING_BRAKES
            RETURN
        ENDIF
        brfg=3                                   ;before taxi / taxi out
        GOSUB br_play                                
    ENDIF
    ONEXP_CLEAR dep_beforetaxi
    ONEXP_TRUE FLAPS_LEFT_POSITION>0 OR NOT ON_GROUND GOSUB dep_taxi
    RETURN

dep_taxi:
    ONEXP_CLEAR dep_taxi
    br_time(20,10) 
    ONEXP_TRUE NOT INRANGE(60*MINUTE+SECOND,time0,brtime) GOSUB dep_beforeto
    RETURN

dep_beforeto:
    IF THROTTLE_1<.85 AND ON_GROUND AND brfg<4
        IF THROTTLE_1>.5 
            br_time(5,0)
            RETURN
        ENDIF
        brfg=4                                   ;before take-off
        GOSUB br_play                                
    ENDIF
    ONEXP_CLEAR dep_beforeto
    RETURN

des_chk:
    ONEXP_CLEAR des_chk
    ONEXP_TRUE NOT INRANGE(PLANE_ALT/crzalt,.7,1.1) GOSUB alt_chk
    IF belts<2
        RETURN
    ENDIF

alt_chk:
    IF PLANE_ALT>crzalt
        IF brfg<5
            brfg=5                               ;climb
            GOSUB br_play                                
        ENDIF
        crzalt=PLANE_ALT
    ELSE
        IF brfg<7 AND ra>2500
            brfg=7                               ;descent
            GOSUB br_play                                
        ENDIF
        ONEXP_CLEAR alt_chk
        ONEXP_TRUE ON_GROUND GOSUB arr_touchdown
    ENDIF
    RETURN

arr_touchdown:
    ONEXP_CLEAR arr_touchdown                   
    IF FLAPS_LEFT_POSITION>0
        ONEXP_TRUE FLAPS_LEFT_POSITION=0 GOSUB arr_taxichk
    ENDIF
    RETURN

arr_taxichk:
    ONEXP_CLEAR arr_taxichk
    br_time(10,10)
    ONEXP_TRUE NOT INRANGE(60*MINUTE+SECOND,time0,brtime) GOSUB arr_taxi 
    RETURN

arr_taxi:
    IF THROTTLE_1<.85 AND ON_GROUND AND brfg<8
        IF THROTTLE_1>.5
            br_time(5,0)
            RETURN
        ENDIF
        brfg=8                                   ;taxi in
        GOSUB br_play                                
        br_time(20,20)
        ONEXP_TRUE NOT INRANGE(60*MINUTE+SECOND,time0,brtime) GOSUB arr_taxi2
    ENDIF
    ONEXP_CLEAR arr_taxi
    RETURN

arr_taxi2:
    IF THROTTLE_1<.85 AND ON_GROUND AND brfg<9
        IF THROTTLE_1>.5
            br_time(5,0)
            RETURN
        ENDIF
        brfg=9                                   ;taxi in
        GOSUB br_play                           
    ENDIF
    ONEXP_CLEAR arr_taxi2
    RETURN

br1:
    PLAY "pregndbr"
    RETURN
br2:
    PLAY "gndbrief"
    RETURN
br3:
    PLAY "pretaxbr"
    RETURN
br4:
    PLAY "tobrief"
    RETURN
br5:
    PLAY "airbrief"
    RETURN
br6:
    PLAY "bumbrief"
    RETURN
br7:
    PLAY "desbrief"
    RETURN
br8:
    PLAY "arivbrie"
    RETURN
br9:
    PLAY "arrvbrie"
    RETURN
